
   
    include \masm32\include\masm32rt.inc
    ;include \masm32\macros\macros.asm
    include \Programming\Adventure32\Data.asm

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib

    SetTextColor PROTO :DWORD,:DWORD
    SetScreenColor PROTO :DWORD,:DWORD
    SetCellColor PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;**************************************************************************

.code

SetTextColor proc fore:DWORD,back:DWORD

    mov eax,back            ;get background colour
    shl eax,4
    or  eax,fore            ;get foreground colour
    invoke SetConsoleTextAttribute,hConsoleOutput,eax
    ret
    
SetTextColor endp

; -------------------------------------------------------------------------

SetScreenColor proc fore:DWORD,back:DWORD

    LOCAL noc    :DWORD
    LOCAL cnt    :DWORD
    LOCAL sbi    :CONSOLE_SCREEN_BUFFER_INFO

    invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR sbi
    mov eax,sbi.dwSize
    push ax
    rol eax,16
    mov cx,ax
    pop ax
    mul cx
    cwde
    mov cnt,eax
    mov edx,back
    shl edx,4
    or  edx,fore
    invoke FillConsoleOutputAttribute,hConsoleOutput,edx,cnt,NULL,ADDR noc
    ret

SetScreenColor endp

; -------------------------------------------------------------------------

SetCellColor proc fore:DWORD,back:DWORD,x:DWORD,y:DWORD,n:DWORD

    LOCAL noc    :DWORD
    LOCAL coord  :DWORD

    mov edx,back            ;get background colour
    shl edx,4               ;mov it into bits 4 to 7
    or  edx,fore            ;foregound colour in Lo 4 bits
    mov ecx,x               ;get column
    mov eax,y               ;get row
    shl eax,16              ;mov into Hi 16 bits (row)
    mov ax,cx               ;mov into Lo 16 bits (column)
    mov coord,eax           ;prime coordinate
    mov ecx,n               ;number of character cells
    
    invoke FillConsoleOutputAttribute,hConsoleOutput,edx,ecx,coord,ADDR noc
    ret

SetCellColor endp

; -------------------------------------------------------------------------

SetSmallRect proc ps_r:DWORD,left:DWORD,top:DWORD,right:DWORD,bottom:DWORD

    mov edx,ps_r
    mov eax,left
    mov [edx].SMALL_RECT.Left,ax
    mov eax,top
    mov [edx].SMALL_RECT.Top,ax
    mov eax,right
    mov [edx].SMALL_RECT.Right,ax
    mov eax,bottom
    mov [edx].SMALL_RECT.Bottom,ax
    
    invoke SetConsoleWindowInfo,hConsoleOutput,TRUE,ADDR small_rect
    ret
    
SetSmallRect endp

; -------------------------------------------------------------------------

hidecursor:
    invoke GetConsoleCursorInfo,hConsoleOutput,addr cci
    mov cci.bVisible,FALSE
    invoke SetConsoleCursorInfo,hConsoleOutput,addr cci
    ret

; -------------------------------------------------------------------------

showcursor:
    invoke GetConsoleCursorInfo,hConsoleOutput,addr cci
    mov cci.bVisible,TRUE
    invoke SetConsoleCursorInfo,hConsoleOutput,addr cci
    ret

; -------------------------------------------------------------------------

instructions:
    cls
    loc 12 ,5
    lea esi,ms487
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 20,10
    Invoke SetTextColor,yellow,0
    lea esi,ms488
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 20,12
    lea esi,ms489
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 20,14
    lea esi,ms490
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 20,16
    lea esi,ms491
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 20,18
    lea esi,ms492
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 28,30
    Invoke SetTextColor,light_cyan,0
    lea esi,ms493
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    getkey
    cls
    Invoke SetTextColor,yellow,0
    loc 9,2
    lea esi,ms1
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,10
    lea esi,ms2
    movzx ecx,word ptr[esi]
    add esi,2
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,19
    lea esi,ms3
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    Invoke SetTextColor,light_cyan,0
    loc 21,30
    lea esi,ms494
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    getkey

kyinst:
    cls
    loc 30,1
    Invoke SetTextColor,light_green,0
    lea esi,ms495
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 7,3
    Invoke SetTextColor,bright_white,0
    lea esi,ms4
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    Invoke SetTextColor,light_cyan,0
    loc 7,6
    lea esi,ms5
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    Invoke SetTextColor,bright_white,0
    loc 7,8
    lea esi,ms6
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 7,11
    Invoke SetTextColor,yellow,0
    lea esi,ms7
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    Invoke SetTextColor,light_red,0
    loc 7,13
    print "L "
    loc 7,15
    print "N "
    loc 7,17
    print "S "
    loc 7,19
    print "E "
    loc 7,21
    print "W "
    loc 7,23
    print "U "
    loc 7,25
    print "D "
    loc 7,27
    print "I "
    loc 7,29
    print "Z "
    loc 7,31
    print "X "
    loc 7,33
    print "Q "
    loc 7,35
    print "C "
    loc 7,37
    print "O "
    loc 7,39
    print "P "
    loc 7,41
    print "K "
    Invoke SetTextColor,light_cyan,0
    loc 9,13
    lea esi,ms496
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,15
    lea esi,ms497
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,17
    lea esi,ms498
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,19
    lea esi,ms499
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,21
    lea esi,ms500
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,23
    lea esi,ms501
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,25
    lea esi,ms502
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,27
    lea esi,ms503
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,29
    lea esi,ms504
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,31
    lea esi,ms505
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,33
    lea esi,ms506
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,35
    lea esi,ms507
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,37
    lea esi,ms508
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,39
    lea esi,ms509
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 9,41
    lea esi,ms510
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    loc 25,43
    Invoke SetTextColor,light_magenta,0
    lea esi,ms511
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    getkey
    ret

;**************************************************************************

start:
    call main
    exit

;**************************************************************************

main proc
    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hConsoleOutput,eax
    invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR csbi
    mov ax,45
    shl eax,16
    mov ax,csbi.dwSize.x
    mov ax,80
    invoke SetConsoleScreenBufferSize,hConsoleOutput,eax
    invoke SetSmallRect,ADDR small_rect,0,0,79,44
    invoke SetScreenColor,0,0
    cld
    invoke GetConsoleCursorInfo,hConsoleOutput,addr cci
    mov cci.dwSize,100
    invoke SetConsoleCursorInfo,hConsoleOutput,addr cci

; ------------------------------------

restart:
    cls
    call hidecursor
    loc 30,20
    Invoke SetTextColor,yellow,0
    lea esi,ms484
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    mov timeout,320
    invoke Sleep,3000
    cmp qtfl,1
    je @F
    lea esi,location
    lea edi,restartdata
    mov ecx,257
    rep movsb
    jmp ask

@@: lea edi,location
    lea esi,restartdata
    mov ecx,257
    rep movsb
    mov qtfl,0
    
ask: 
    loc 28,30
    Invoke SetTextColor,light_magenta,0
    lea esi,ms485
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    Invoke SetTextColor,light_green,0
    loc 37,34
    lea esi,ms486
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL

gky:
    getkey
    cmp al,"y"
    jz @F
    cmp al,"Y"
    jnz no
@@: call instructions
    jmp @F

no: cmp al,"n"
    je @F
    cmp al,"N"
    jne gky
    
@@: invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR csbi
    mov ax,500
    shl eax,16
    mov ax,csbi.dwSize.x
    mov ax,80
    invoke SetConsoleScreenBufferSize,hConsoleOutput,eax
    invoke SetSmallRect,ADDR small_rect,0,0,79,44
    invoke SetScreenColor,0,0
    call showcursor
    
; 
;    MAIN LOOP   
; 

Look:                                ;Display current location description
    cls                              ;Clear screen
    mov rowpos,0 
    loc 0,0
    movzx ebx,location
    mov al,directions[ebx-1]
    test al,1                         ;Is it dark?
    jz printdescription               ;No, go past routine
    cmp byte ptr flags[1],1           ;Is lamp lit
    jnz @F                            ;No, goto cannot see
    cmp lamp,128                      ;Is lamp carried?
    je printdescription
    mov al,location
    cmp al,lamp                       ;No, is it at current location?
    jz printdescription               ;Yes, go past routine
    
@@: add rowpos,2 
    movzx ecx,rowpos
    Invoke SetTextColor,light_red,0
    lea esi,ms483
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    jmp prompt                       ;Loop for next input (KEYBOARD)
    
printdescription:
    Invoke SetTextColor,yellow,0
    lea esi,ms512
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    lea esi,descriptions-4            ;Point at descriptions for indexing.
    movzx ebx,location                ;Get current location.
    cmp ebx,34
    jne @F
    cmp ringpulls,4
    jne @F
    mov ebx,113
    
@@: push ebx                          ;Save location
    shl ebx,2
    mov esi,[esi+ebx]                 ;Get current location description.
    sub eax,eax
    mov al,[esi]
    inc esi
    mov rowpos,ax
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL

; ************************************
;    Objects   
; ************************************

    mov ycsee,0                  ;Clear 'You can see' ,on screen, flag.
    lea edi,lamp-1               ;Point at objects status - 1 for indexing
    lea esi,objectdescriptions-4 ;Point at descriptions - 4 for indexing
    mov ecx,59                   ;Number of objects + 1 for indexing
    pop eax                      ;Restore location number
    cmp eax,113
    jne t2
    mov eax,34
    
t2: dec ecx                      ;Objects = objects - 1
    jz exits                     ;All done ? yes goto 'There is a way'
    add esi,4                    ;Next description
    inc edi
    cmp al,[edi]                 ;Is object at current location ?
    jnz t2                       ;No, loop for next object
    push esi                     ;Save pointer
    push ecx
    push eax
    push edi
    cmp ycsee,0                  ;Yes, is 'You can see' on screen ?
    jnz @F                       ;Yes, goto print description
    push esi                     ;Resave pointer.
    inc ycsee
    movzx ecx,rowpos  
    loc 0,ecx
    Invoke SetTextColor,light_cyan,0
    lea esi,ms513
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    pop esi                       ;Restore pointer.
    
@@: mov esi,[esi]                 ;Get description
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    inc rowpos
    movzx ebx,rowpos
    loc 12,ebx
    pop edi
    pop eax
    pop ecx
    pop esi                       ;Restore pointer.
    jmp t2                        ;Loop for next object.

; ************************************
;   DIRECTIONS 
; ************************************

exits:
    cmp ycsee,1
    jz @F
    movzx ecx,rowpos
    loc 0,ecx
    jmp n1
    
@@: add rowpos,1
    movzx ecx,rowpos
    loc 0,ecx
    
n1: Invoke SetTextColor,white,0
    lea esi,ms514
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    mov ecx,6
    movzx ebx,location
    lea esi,directions-1
    mov al,[esi+ebx]
    and al,254                   ;Clear dark indicator
    lea esi,ways                 ;Point at N,S,E,W,U,D
    
@@: push esi
    push eax
    push ecx
    test al,128                  ;Direction available?
    jns t5                       ;No, prepare for next.
    mov esi,[esi]                ;Get description
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    
t5: pop ecx
    pop eax
    pop esi
    add esi,4                    ;Point at next direction.
    shl al,1                     ;Move next indicator into sign bit.
    dec ecx
    jnz @B
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx

; ************************************
;    Secondary Loop  
; ************************************

hifnl:                            ;return here if not 'Look'
    cmp byte ptr flags[74],1
    je rmble
    cmp byte ptr flags[1],0       ;Is lamp lit?
    jz rmble                      ;No, bypass routine.
    dec lit                       ;Yes, lit = lit-1
    jnz @F                        ;lit = 0?
    mov byte ptr flags[1],0       ;Yes douse lamp.
    jmp rmble                     ;No, bypass routine.
    
@@: cmp lit,10                    ;More than 10 turns left?
    jg rmble                      ;Yes, bypass routine.
    Invoke SetTextColor,light_red,0
    movzx ecx,rowpos               ;No, blankline.
    loc 0,ecx
    movzx ebx,lit
    shl ebx,2
    lea esi,turns-4
    mov esi,[esi+ebx]
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi, ecx, ADDR numrit,NULL
    movzx ecx,rowpos
    add rowpos,2
    loc 0,ecx

rmble:
    mov byte ptr flags[74],0
    cmp byte ptr flags[6],0
    jz prompt
    cmp location,76
    jnz prompt
    mov byte ptr flags[6],0
    lea edi,directions-1
    and byte ptr[edi+44],239
    lea esi,descriptions-4
    mov edi,esi
    lea esi,[esi+304]
    lea edi,[edi+176]
    mov eax,[esi]
    mov [edi],eax
    lea esi,ms26
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    movzx ecx,rowpos
    add rowpos,2

; -------------------------------------------------------------------------

prompt:
    movzx ecx,rowpos
    loc 0,ecx
    cmp ale,0
    jz @F
    cmp drunk,0
    jz @F
    cmp ale,2
    jne @F
    dec drunk
    jz e1
    Invoke SetTextColor,light_green,0
    lea esi,ms515
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    jmp e2

e1: cmp ale,2
    jne @F
    dec ale

@@: Invoke SetTextColor,light_green,0
    lea esi,ms516
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL

e2: Invoke SetTextColor,brown,0
    mov lettercount,0        ;Clear input letters (keyboard) counter.
    mov colpos,10
    lea edi,buff             ;Point at keyboard transfer buffer.
    mov wkbuff,edi

keyboard:
    invoke Sleep,50
    call crt__kbhit
    test eax,eax
    jnz @F
    cmp kpr,1               ;keypress taken place?
    jz keyboard
    dec timeout             ;18 seconds since keypress?
    jne keyboard
    jmp timedevents

@@: call crt__getch         ;recover character in buffer & return it in eax
    cmp al,13               ;enter
    jne @F
    cmp lettercount,0
    je keyboard
    jmp parser

@@: cmp al,8                ;backspace
    jne space
    cmp lettercount,0
    je keyboard
    dec lettercount
    dec colpos
    mov edi,wkbuff
    dec edi
    mov wkbuff,edi
    movzx edi,colpos
    movzx esi,rowpos  
    invoke SetCellColor,0,0,edi,esi,1
    movzx edi,colpos
    movzx esi,rowpos
    loc edi,esi
    cmp cursorflag,1
    jne @F
    dec cursorflag

@@: call showcursor
    jmp keyboard

space:                       ;spacebar
    cmp lettercount,20
    je keyboard
    cmp al,32
    je accept
    cmp al,041            ;'A'
    jb keyboard
    cmp al,05Ch           ;'Z'
    jbe accept
    cmp al,061h           ;'a'
    jb keyboard
    cmp al,07ah           ;'z'
    ja keyboard

accept:
    cmp lettercount,20    ;buffer full?
    jz keyboard
    inc lettercount
    cmp lettercount,20
    jne @F
    call hidecursor
    inc cursorflag

@@: inc colpos
    mov kpr,1
    mov edi,wkbuff
    push edi
    pop esi
    mov [edi],al
    inc edi
    mov wkbuff,edi
    invoke WriteConsoleA,hConsoleOutput,esi,1,ADDR numrit,NULL
    jmp keyboard

; -------------------------------------------------------------------------

parser:
    cmp cursorflag,1
    jne @F
    dec cursorflag
    call showcursor

@@: mov kpr,0
    cmp lettercount,1
    jne checkwords
    mov ebx,16             ;15 single letter commands+1 for loop
    lea edi,sletters-1
    lea esi,buff
    mov al,[esi]
    cmp al,"a"
    jae @F
    add al,32

@@: dec ebx
    jne @V
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    jmp pardon

@V: inc edi
    cmp al,[edi]
    jne @B

SWITCH ebx

    case 1
        call hidecursor
        invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR csbi
        mov ax,45
        shl eax,16
        mov ax,csbi.dwSize.x
        mov ax,80
        invoke SetConsoleScreenBufferSize,hConsoleOutput,eax
        invoke SetSmallRect,ADDR small_rect,0,0,79,44
        invoke SetScreenColor,0,0
        call kyinst
        invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR csbi
        mov ax,500
        shl eax,16
        mov ax,csbi.dwSize.x
        mov ax,80
        invoke SetConsoleScreenBufferSize,hConsoleOutput,eax
        invoke SetSmallRect,ADDR small_rect,0,0,79,44
        invoke SetScreenColor,0,0
        call showcursor
        jmp Look
    case 2
        ret
    case 3
        jmp ldsk
    case 4
        jmp sdsk
    case 5
        jmp quit
    case 6
        jmp lram
    case 7
        jmp sram
    case 8
        jmp inventory
    case 9
        jmp god
    case 10
        jmp gou
    case 11
        jmp gow
    case 12
        jmp goe
    case 13 
        jmp gos
    case 14
        jmp gon
    case 15 
        jmp Look

    DEFAULT
        jmp pardon
ENDSW

; -------------------------------------------------------------------------

stringsearch:               ;search string for match to input
    push esi                ;save buffer address
    mov ecx,1               ;initialise parser count

n2: mov ebx,3               ;three characters to check

nch:
    mov al,[esi]             ;get input character
    inc esi
    cmp al,'a'               ;is it lower case ?
    jae @F
    add al,32                ;if not convert it

@@: scasb                    ;is input charater = to string character ?
    jne neword               ;no, goto next word
    dec ebx                  ;letters checked = letters checked - 1
    jne nch                  ;all checked? no check next character.
    jmp fin                  ;match found, exit.

neword:                      ;next word
    dec edi                  ;adjust address.
    inc ecx                  ;parser = parser + 1
    cmp ecx,cow              ;all words checked ?
    je @F                    ;yes, no match found return to caller
    lea edi,[edi+ebx]        ;point at start of next string word
    pop esi                  ;restore buffer address
    push esi                 ;and resave it
    jmp n2                   ;goto next word to be checked
    
@@: inc nomatch              ;set no match found flag

fin:
    pop esi                  ;clean stack
    ret

; -------------------------------------------------------------------------

checkwords:
    cmp lettercount,7
    jae @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    jmp pardon
    
@@: lea esi,buff
    lea edi,verbs
    mov nomatch,0               ;clear no match found flag
    mov cow,42                  ;Legal verbs+1 in counter
    call stringsearch           ;Search for verb match
    cmp nomatch,1               ;has a match been found ?
    jne nouncheck               ;Yes, goto noun checking routine

notstood:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    lea esi,ms517
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
nouncheck:                       ;Noun checking routine
    mov verbstore,ecx            ;store number of verb
    movzx ecx,lettercount        ;get number of input characters
    dec esi                      ;Correct address for loop search
                                 ;Search characters for space
@@: dec ecx                      ;characters = characters - 1
    jz notstood                  ;all done ? yes, goto not understood
    inc esi                      ;next character
    cmp byte ptr[esi],32         ;is it a space ?
    jnz @b                       ;no, loop for next character
    mov cow,132                  ;store in counter legal nouns + 1
    lea edi,nouns                ;point at noun string
    inc esi                      ;point at start of input noun
    call stringsearch            ;search string for match
    cmp nomatch,1                ;match found ?
    jz notstood                  ;no, goto not understood
    mov nounstore,ecx            ;store noun number
    mov ebx,verbstore
    Invoke SetTextColor,bright_white,0

SWITCH ebx

    case 1
        jmp takeget
    case 2
        jmp takeget
    case 3
        jmp drop
    case 4
        jmp say
    case 5
        jmp light
    case 6
        jmp douse
    case 7
        jmp make
    case 8
        jmp knock
    case 9
        jmp read
    case 10
        jmp eat
    case 11
        jmp pushpress
    case 12 
        jmp pushpress
    case 13
        jmp pull
    case 14 
        jmp open
    case 15
        jmp examine
    case 16
        jmp climb
    case 17
        jmp give
    case 18
        jmp play
    case 19
        jmp load
    case 20
        jmp shoot
    case 21
        jmp unlock
    case 22
        jmp kiss
    case 23
        jmp grease
    case 24
        jmp use
    case 25
        jmp wear
    case 26 
        jmp buy
    case 27
        jmp wrte
    case 28 
        jmp insert
    case 29
        jmp dig
    case 30
        jmp fill
    case 31
        jmp break
    case 32
        jmp lace
    case 33
        jmp kill
    case 34
        jmp drink
    case 35
        jmp throw
    case 36
        jmp sew
    case 37
        jmp repairmend
    case 38
        jmp repairmend
    case 39
        jmp turn
    case 40
        jmp turn
    case 41
        jmp swim    

    DEFAULT
        jmp notstood
ENDSW

; -------------------------------------------------------------------------

pardon:
    Invoke SetTextColor,light_red,0
    lea esi,ms519
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;     SINGLE LETTERS    
; ************************************

cannotgo:                     ;cannot go that way routine
    add rowpos,2
    movzx edi,rowpos
    loc 0,edi
    Invoke SetTextColor,light_red,0
    lea esi,ms518
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

addone:
    inc bl

newloc:                         ;change of location routine
    mov darkcount,0             ;clear dark counter
    mov location,bl             ;store new location
    cmp bl,37                   ;east side of lake ?
    jne Look                    ;no
    mov byte ptr flags[7],0     ;Clear lake monster flag
    jmp Look                    ;Display location description etc.

; -------------------------------------------------------------------------

dirstatus:
    movzx ebx,location
    lea esi,directions-1
    mov al,[esi+ebx]            ;get direction indicator of current location
    test al,1                   ;is it a dark location?
    jne @F
    ret

@@: cmp lamp,128
    jne @F
    cmp byte ptr flags[1],0
    jz @F
    ret

@@: cmp bl,lamp
    jnz @F
    cmp byte ptr flags[1],0
    je @F
    ret

@@: cmp darkcount,1
    je fall
    inc darkcount
    Invoke SetTextColor,light_red,0
    add rowpos,2
    movzx edi,rowpos
    loc 0,edi
    lea esi,ms27
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    pop esi
    jmp hifnl

fall:
    call hidecursor
    cls
    mov ctx,35
    loc 21,4
    Invoke SetTextColor,bright_white,0
      
@@: invoke Sleep,30
    print "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAGH!"
    print "                                         "
    dec ctx
    jne @B
    call hidecursor
    invoke Sleep,3000
    pop esi

fail:
    cls
    invoke SetTextColor,light_red,0
    loc 35,21
    lea esi,ms520
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    invoke Sleep,2500
    loc 28,39
    invoke SetTextColor,light_green,0
    lea esi,ms521
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    mov qtfl,1
    getkey
    call showcursor
    jmp restart

; ************************************
;      LOAD OLD GAME     
; ************************************

ldsk:
    invoke CreateFile,ADDR Cload,GENERIC_READ,FILE_SHARE_READ,\
    NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
    mov Handledatafile,eax
    invoke ReadFile,Handledatafile,ADDR location,Filesize,ADDR bytes_read,NULL
    invoke CloseHandle,Handledatafile
    jmp Look

; ************************************
;    SAVE GAME   
; ************************************

sdsk:
    invoke CreateFile,ADDR Cload,GENERIC_WRITE,FILE_SHARE_READ,\
    NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
    mov Handledatafile,eax
    invoke WriteFile,Handledatafile,ADDR location,Filesize,ADDR bytes_read,NULL
    invoke CloseHandle,Handledatafile
    cls
    call hidecursor
    invoke SetTextColor,light_green,black
    loc 34,24
    lea esi,ms522
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    invoke Sleep,3000       ;3 sec delay
    call showcursor
    ret

; ************************************
;     QUIT    
; ************************************

quit:
    cls
    call hidecursor
    loc 17,20
    invoke SetTextColor,light_magenta,0
    lea esi,ms523
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    invoke SetTextColor,light_green,0
    loc 37,34
    lea esi,ms486
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    
gkey:
    getkey
    cmp al,"y"
    jz @F
    cmp al,"Y"
    jnz noo
    
@@: mov qtfl,1
    jmp restart

noo: 
    cmp al,"n"
    je @F
    cmp al,"N"
    jne gkey
    
@@: cls 
    call showcursor
    jmp Look
    
; ************************************  
;    QUICK LOAD  
; ************************************ 

lram:
    cmp quicksave,1
    je @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    lea esi,ms524
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: lea esi,quicksavedata
    lea edi,location
    mov ecx,257
    rep movsb
    add rowpos,2
    jmp Look

; ************************************ 
;    QUICK SAVE   
; ************************************ 

sram:
    mov quicksave,1
    lea edi,quicksavedata
    lea esi,location
    mov ecx,257
    rep movsb
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms525
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; ************************************ 
;      INVENTORY     
; ************************************ 

inventory:
    cmp carry,0                  ;carrying anything ?
    jne @F                       ;yes, goto routine
    cmp worn,0
    jne @F
    
ncy:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    lea esi,ms526
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp carry,0
    je @T                       ;if all worn goto wearing routine
    mov al,carry                ;get number of objects carried & worn
    mov tobc,al                 ;store objects in counter
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,brown,0
    lea esi,ms527
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    lea esi,lamp                 ;get objects status.
    lea edi,objectdescriptions-4 ;get objects descriptions.
        
@C: add edi,4                    ;next description.
    mov al,[esi]                 ;get object status.
    inc esi
    cmp al,128
    jne @C
    push esi
    push edi
    mov esi,[edi]
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    cmp tobc,1
    je @F
    inc rowpos
    movzx ecx,rowpos
    loc 17,ecx
    
@@: pop edi
    pop esi
    dec tobc
    jne @C
    cmp worn,0                   ;anything worn ?
    jz @l8                       ;no, return
    
@T: add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms528
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    mov al,worn
    mov tobc,al
    lea esi,lamp                 ;get objects status.
    lea edi,objectdescriptions-4 ;get objects descriptions.
        
@D: add edi,4                    ;next description.
    mov al,[esi]                 ;get object status.
    inc esi
    cmp al,192
    jne @D
    push esi
    push edi
    mov esi,[edi]
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    cmp tobc,1
    je @F
    inc rowpos
    movzx ecx,rowpos
    loc 17,ecx
    
@@: pop edi
    pop esi
    dec tobc
    jne @D
    
@l8:
    add rowpos,2
    jmp hifnl

; ************************************
;     DOWN     
; ************************************

god:
    call dirstatus
    test al,4
    jz cannotgo
    cmp bl,80
    jne @F
    sub bl,8
    jmp newloc
    
@@: cmp bl,12
    jz addone
    cmp bl,13
    jz addone
    cmp bl,39
    je @F
    dec bl
    jmp newloc
    
@@: cmp boots,192
    jne @F
    dec bl
    jmp newloc
    
@@: add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms28
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    dec bl
    jmp newloc

; ************************************
;      UP      
; ************************************
    
gou:
    call dirstatus
    test al,8
    jz cannotgo
    cmp bl,72
    jne @Q
    cmp butler,bl
    je @F
    add bl,8
    jmp newloc
    
@@: add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms29
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@Q: cmp bl,13
    jne @F
    dec bl
    jmp newloc
    
@@: cmp bl,14
    jne @F
    dec bl
    jmp newloc
    
@@: cmp bl,37
    jne @F
    cmp boots,192
    je addone
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms28
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    jmp addone
    
@@: cmp bl,97
    je @F
    cmp bl,105
    jne addone

@@: cmp cloak,128
    je fc
    cmp cloak,192
    je fc
    jmp addone

; ************************************
;     WEST     
; ************************************

gow:
    cmp location,102
    jne @F
    cmp byte ptr flags[65],1
    je @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    lea esi,ms35
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: call dirstatus
    test al,16
    jz cannotgo
    cmp bl,7
    jne @F
    add bl,17
    jmp newloc
    
@@: cmp bl,8
    jne @F
    add bl,15
    jmp newloc
    
@@: cmp bl,14
    jne @F
    sub bl,6
    jmp newloc
    
@@: cmp bl,23
    jne @F
    sub bl,7
    jmp newloc
    
@@: cmp bl,37
    jne @F
    cmp boat,128
    jne ship
    cmp plank,128
    jne paddle
    sub bl,8
    jmp newloc
    
@@: cmp bl,65
    jz Look
    cmp bl,74
    jne @F
    sub bl,9
    jmp newloc

@@: cmp bl,53
    je @F
    sub bl,8
    jmp newloc
    
@@: cmp bl,jailer
    je @F
    sub bl,8
    jmp newloc
    
@@: add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms30
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nothap:
    lea esi,ms36
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;     EAST     
; ************************************

goe:
    cmp location,47
    jne @F
    cmp byte ptr flags[71],1
    je @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    lea esi,ms35
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: call dirstatus
    test al,32
    jz cannotgo
    cmp bl,7
    jne @F
    add bl,9
    jmp newloc
    
@@: cmp bl,8
    jne @F
    add bl,7
    jmp newloc
    
@@: cmp bl,14
    jne @F
    add bl,10
    jmp newloc
    
@@: cmp bl,15
    jz addone
    cmp bl,16
    jne @F
    add bl,7
    jmp newloc
    
@@: cmp bl,21
    jne ll6
    cmp boat,128
    je @F
    
ship:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms31
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[57],0
    jne @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms34
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp plank,128
    jne paddle
    add bl,8
    jmp newloc
    
paddle:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms37
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
ll6:
    cmp bl,23
    jne @F
    sub bl,15
    jmp newloc
    
@@: cmp bl,24
    jne @F
    sub bl,16
    jmp newloc
    
@@: cmp bl,29
    jne @F
    cmp compoint,0
    jz Look
    cmp compoint,2
    jnz Look
    mov compoint,0
    add bl,8
    jmp newloc
    
@@: cmp bl,90
    jz Look
    cmp bl,97
    jne l12
    cmp sord,128
    je @F
    sub bl,24
    jmp newloc
    
@@: cmp cloak,128
    je fc
    cmp cloak,192
    je fc
    add bl,8
    jmp newloc
    
l12:
    cmp bl,64
    je @F
    add bl,8
    jmp newloc
    
@@: cmp byte ptr flags[66],0
    je @F
    add bl,8
    jmp newloc
    
@@: Invoke SetTextColor,light_red,0
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms8
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,8000
    jmp fail

; ************************************ 
;    SOUTH     
; ************************************
    
gos:
    call dirstatus
    cmp location,43
    jne @F
    cmp byte ptr flags[69],1
    jne AA
    dec bl
    jmp newloc
    
AA: add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms33
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp location,12
    jne @F
    Invoke SetTextColor,bright_white,0
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms32
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: test al,64
    jz cannotgo
    cmp bl,65
    jz Look
    cmp bl,73
    jne @F
    sub bl,8
    jmp newloc
    
@@: cmp bl,29
    jne @F
    cmp compoint,0
    jz Look
    cmp compoint,1
    jnz Look
    add bl,8
    jmp newloc
    
@@: cmp bl,81
    jne @F
    sub bl,16
    jmp newloc
    
@@: cmp bl,89
    jnz @F
    sub bl,24
    jmp newloc

@@: cmp bl,7
    je @F
    dec bl
    jmp newloc
    
@@: cmp byte ptr flags[11],1   ;gypsy
    jne @F
    dec bl
    jmp newloc
    
@@: add bl,15
    jmp newloc

; ************************************   
;    NORTH     
; ************************************

gon:
    call dirstatus
    cmp location,11
    jne @F
    Invoke SetTextColor,bright_white,0
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms32
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: test al,128
    jne @F
    cmp location,102
    jne cannotgo
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0

drawup:
    lea esi,ms38
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp bl,8
    jne @F
    add bl,16
    jmp newloc
    
@@: cmp bl,16
    jne @F
    dec bl
    jmp newloc
    
@@: cmp bl,24
    jne @F
    sub bl,16
    jmp newloc
    
@@: mov ecx,4
    lea esi,btl-1
    
@@: inc esi
    cmp bl,[esi]
    jz Look
    dec ecx
    jne @B
    cmp bl,84
    jne addone
    
force:
    cmp cloak,128
    je fc
    cmp cloak,192
    jne addone
    
fc: add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms39
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    ACTIONS   
; ************************************

cannotdo:
    Invoke SetTextColor,light_red,0
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms40
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

already:
    Invoke SetTextColor,light_red,0
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms41
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

noquip:
    Invoke SetTextColor,light_red,0
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms42
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------   

pickup:
    cmp carry,12                 ;carrying more than 12 items ?
    jb @F                        ;yes, do not pick up (all)
    ret

@@: cmp all,0                    ;anything already picked up ?
    jne @F                       ;yes, goto pick up next
    inc all                      ;no, first item, set flag
    
@@: mov byte ptr[esi+ebx],128    ;sign bit = object carried
    inc carry                    ;items carried = items carried + 1
    ret

; ************************************
;  TAKE/GET  
; ************************************

takeget:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp carry,12                  ;carrying 12 objects or more ?
    jb @F                         ;no, loop past
    Invoke SetTextColor,light_red,0
    lea esi,ms43
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov ebx,nounstore             ;get object number
    lea esi,lamp-1                ;point at objects status - 1 for indexing
    movzx eax,location            ;get current location number
    cmp ebx,50                    ;is noun 'all' ?
    jne kk                        ;no, loop past.
    mov all,0                     ;clear flag, objects picked up in 'all'.
    
@@: dec ebx                       ;objects = objects-1
    je @F                         ;all done? yes loop past.
    lea edi,lamp-1
    cmp al,[ebx+edi]              ;no, is object at current location?
    jne @B                        ;no, loop for next.
    call pickup                   ;yes, pick up _ if total not exceeded.
    jmp @B                        ;loop for next.
    
@@: cmp all,0                     ;anything picked up in 'all' routine?
    je @F
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl                     ;yes, exit routine with confirmation.
    
@@: Invoke SetTextColor,light_red,0
    lea esi,ms44
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
       
kk: cmp ebx,50
    jb @F
    Invoke SetTextColor,light_red,0
    lea esi,ms45
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr[esi+ebx],192
    je @F
    cmp byte ptr[esi+ebx],128
    jne @44
    
@@: Invoke SetTextColor,light_red,0
    lea esi,ms46
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@44:
    cmp al,[esi+ebx]
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms47
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: call pickup
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;   DROP  
; ************************************

dropit:
    mov al,location
    cmp byte ptr[esi+ebx],192
    jne @F
    mov [esi+ebx],al
    dec worn
    ret
    
@@: mov [esi+ebx],al
    dec carry
    ret

; -------------------------------------------------------------------------

nhold:
    Invoke SetTextColor,light_red,0
    lea esi,ms48
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

drop:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp nounstore,40
    jne @F
    cmp byte ptr flags[20],0
    je @F
    lea esi,ms49
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp carry,0
    jne @F
    cmp worn,0
    jz ncy
    
@@: cmp location,29
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms50
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov ebx,nounstore
    lea esi,lamp-1
    cmp ebx,50
    jne k1
    push ebx
    
@6: dec ebx
    cmp byte ptr[esi+ebx],128
    jne @6
    call dropit
    cmp carry,0
    jnz @6
    pop ebx
    cmp worn,0
    je @F

@G: dec ebx
    cmp byte ptr[esi+ebx],192
    jne @G
    call dropit
    cmp worn,0
    jne @G 
    
@@: lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
k1: cmp ebx,49
    ja nhold

@@: cmp byte ptr[esi+ebx],192
    je @F
    cmp byte ptr[esi+ebx],128
    jne nhold
    
@@: call dropit
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;     SAY    
; ************************************

say:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp nounstore,75     ;kiziajas
    jne xastra
    cmp location,3
    je @F
    cmp location,4
    jne nothap
    
@@: cmp amulet,192
    je @F
    
dy: lea esi,ms51
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,7000
    jmp fail
    
@@: cmp location,3
    jne @F
    inc location
    jmp @S
    
@@: dec location

@S: lea esi,ms52
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    mov ecx,5
    movzx edi,rowpos
    sub esi,esi

aa: mov edx,16
    
@@: push ecx
    push edx
    invoke SetCellColor,0,edx,esi,edi,80
    invoke Sleep,11
    pop edx
    pop ecx
    dec edx
    jne @B
    dec ecx
    jne aa
    invoke SetCellColor,bright_white,0,esi,edi,80
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
xastra:
    cmp nounstore,107                  ;xastra
    jne nothap
    cmp location,107
    jne nothap
    cmp byte ptr flags[40],1
    je nothap
    mov byte ptr flags[40],1
    lea esi,directions-1
    or byte ptr[esi+107],128
    lea esi,ms53
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;   LIGHT  
; ************************************

light:
    cmp nounstore,1
    jne m2
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp byte ptr flags[1],0
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms54
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp lamp,128
    jne nhold
    cmp matches,128
    je @F
    
t1: Invoke SetTextColor,light_red,0
    lea esi,ms55
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp lit,0
    je @F
    mov byte ptr flags[1],1
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[60],0
    je @F
    lea esi,ms56
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: Invoke SetTextColor,light_red,0
    lea esi,ms57
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
m2: cmp nounstore,2
    jne @F
    cmp matches,128
    jne t1
    lea esi,ms58
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
@@: cmp nounstore,111     ;gunpowder
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    cmp keg,128
    je @F

nokeg:
    lea esi,ms59
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms60
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,7000
    jmp fail

; ************************************
;    DOUSE  
; ************************************

douse:
    cmp nounstore,1
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp lamp,128
    jne nhold
    cmp byte ptr flags[1],0
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms61
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[1],0
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    MAKE  
; ************************************
    
make:
    cmp nounstore,24   ;flute
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp flute,0
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms62
    movzx ecx,byte ptr[esi]
    inc esi
    add rowpos,2
    jmp hifnl
    
@@: cmp knife,128
    jne noquip
    cmp stem,128
    jne noquip
    mov stem,0
    mov flute,128
    lea esi,ms63
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;     KNOCK    
; ************************************

knock:
    cmp nounstore,78     ;knocker
    jne otherobs
    cmp location,39
    jne noknock
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp byte ptr flags[33],0
    jne nothap
    cmp byte ptr flags[12],0
    jz nothap
    cmp helmet,192
    je @f
    lea esi,ms9
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,8000
    jmp fail
    
@@: mov byte ptr flags[33],1
    lea esi,directions-1
    or byte ptr[esi+39],32
    lea esi,ms10
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl
    
; ************************************
;    READ    
; ************************************

read:
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    mov al,location
    cmp nounstore,76    ;writing
    jne notice
    lea edi,stones
    mov ecx,4
    repne scasb
    jne @F
    lea esi,ms64
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,35
    jne nm
    
b1: cmp byte ptr flags[68],0
    jne @F
    mov byte ptr flags[68],1
    
@@: lea esi,ms65
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
nm: cmp location,41
    jne @F
    lea esi,ms66
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,42
    jne @F

t4: lea esi,ms67
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp location,85
    jne @J
    cmp byte ptr flags[72],1
    je @F
    
@s: mov byte ptr flags[73],1
    lea esi,ms68
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@J: cmp location,56
    jne @F
    print "It says :-"
    Invoke SetTextColor,light_red,0
    movzx ecx,rowpos
    loc 23,ecx
    lea esi,ms69
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL

    inc rowpos
    movzx ecx,rowpos
    loc 29,ecx
    lea esi,ms70
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: Invoke SetTextColor,light_red,0
    lea esi,ms71
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
notice:
    cmp nounstore,92      ;notice
    jne message
    cmp location,42
    je t4
    cmp location,56
    je @J
    cmp location,35
    je b1
    cmp location,85
    jne @F
    cmp byte ptr flags[72],1
    jne @s
    
@@: Invoke SetTextColor,light_red,0
    lea esi,ms72
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
message:
    cmp nounstore,71     ;message
    jne inscription
    cmp location,40
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms73
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms74
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
inscription:
    cmp nounstore,82      ;inscription
    jne music
    cmp location,75
    jne @F
    lea esi,ms75
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: Invoke SetTextColor,light_red,0
    lea esi,ms76
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
music:
    cmp nounstore,65     ;music
    jne sc
    cmp location,67
    je @F
    cmp parchment,128
    jne nomusic
    cmp byte ptr flags[17],0
    je nomusic
    
@@: lea esi,ms77
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

sc: cmp nounstore,48     ;scroll
    je @F
    cmp nounstore,108    ;rhyme
    jnz signpost

@@: cmp scroll,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms78
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms79
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    inc ebx
    loc 22,ebx
    lea esi,ms80
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    inc ebx
    loc 22,ebx
    lea esi,ms81
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    inc ebx
    loc 22,ebx
    lea esi,ms82
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    inc ebx
    loc 22,ebx
    lea esi,ms83
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    inc ebx
    loc 22,ebx
    lea esi,ms84
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,7
    jmp hifnl

; -------------------------------------------------------------------------
    
signpost:
    cmp nounstore,88      ;signpost
    jne engrving
    cmp location,7
    jne @F
    cmp byte ptr flags[11],1
    je @t
    lea esi,ms85
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@t: lea esi,ms86
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,23
    jne nosign
    lea esi,ms85
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
engrving:
    cmp nounstore,109    ;engraving
    jne cannotdo
    cmp paper,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms87
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp glasses,192
    je @F
    lea esi,ms88
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms89
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    movzx ecx,rowpos
    loc 28,ecx
    lea esi,ms90
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; ************************************
;     EAT   
; ************************************

stomach:
    cmp hungry,25
    jae @F
    ret

@@: lea esi,ms91
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    inc chew
    ret

; -------------------------------------------------------------------------
    
meal:
    mov hungry,71
    dec carry
    ret

; -------------------------------------------------------------------------

eat:
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    mov chew,0
    cmp nounstore,20
    jne @3
    cmp bread,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms92
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: call stomach
    cmp chew,0
    je @F
    add rowpos,2
    jmp hifnl
    
@@: mov bread,0
    call meal
    lea esi,ms93
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@3: cmp nounstore,25
    jne @4
    cmp pie,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms94
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: call stomach
    cmp chew,0
    je @F
    add rowpos,2
    jmp hifnl
    
@@: mov pie,0
    call meal
    lea esi,ms95
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@4: cmp nounstore,29
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms96
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp fruit,128
    je @f
    Invoke SetTextColor,light_red,0
    lea esi,ms97
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: call stomach
    cmp chew,0
    je @F
    add rowpos,2
    jmp hifnl
    
@@: mov fruit,0
    call meal
    lea esi,ms98
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;   PUSH/PRESS 
; ************************************

pushpress:
    cmp nounstore,112       ;torch
    jne tc2
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,83
    jne notorch
    cmp byte ptr flags[36],0
    jne nothap
    mov byte ptr flags[36],1
    lea esi,directions-1
    or byte ptr[esi+83],16
    lea esi,ms99
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
tc2:
    cmp nounstore,110       ;button
    jne otherobs
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,109
    jne nobut
    cmp byte ptr flags[46],0
    jne nothap
    mov byte ptr flags[46],1
    lea esi,ms100
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; ************************************
;    PULL   
; ************************************

pull:
    cmp nounstore,54        ;ring
    jne handle
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,34
    jne noring
    cmp ringpulls,4
    je nothap
    cmp ringpulls,3
    jne @F
    inc ringpulls
    lea esi,directions-1
    or byte ptr[esi+34],4
    lea esi,ms101
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp ringpulls,2
    jne @F
    inc ringpulls
    lea esi,ms102
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: inc ringpulls
    jmp nothap

; -------------------------------------------------------------------------
    
handle:
    cmp nounstore,64        ;handle
    jne sorwd
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,45
    jne @58
    cmp byte ptr flags[1],1
    je @F
    
@11:
    lea esi,ms103
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp lamp,128
    je @F
    mov al,location
    cmp al,lamp
    jne @11
    
@@: cmp byte ptr flags[6],1
    je nothap
    mov byte ptr flags[6],1
    lea esi,directions-1
    or byte ptr[esi+44],16
    lea esi,descriptions-4
    mov edi,esi
    lea esi,[esi+208]
    lea edi,[edi+176]
    mov eax,[esi]
    mov [edi],eax
    lea esi,ms26
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
sorwd:                     ;sword
    cmp nounstore,21
    jnz lver
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx

@58:
    cmp location,112
    jne nohandle
    cmp byte ptr flags[32],0
    jne nohandle
    cmp byte ptr flags[19],0
    jne @F
    lea esi,ms105
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp gloves,192
    je @F
    
@65:
    lea esi,ms106
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[32],1
    inc carry
    mov sord,128
    lea esi,ms11
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

; -------------------------------------------------------------------------
    
lver:
    cmp nounstore,63       ;lever
    jne cor
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,94
    jne nolever
    lea esi,ms107
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    
@@: getkey
    cmp al,'a'
    je @F
    cmp al,'A'
    jne @10
    
@@: cmp byte ptr flags[62],0
    je @F
    jmp nothap
    
@@: cmp byte ptr flags[30],0
    jne @F
    
b3: Invoke SetTextColor,light_red,0
    lea esi,ms108
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,7000
    jmp fail
    
@@: mov byte ptr flags[62],1
    lea esi,directions-1
    or byte ptr [esi+102],128
    lea esi,ms109
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@10:
    cmp al,'b'
    je @F
    cmp al,'B'
    jne cc
    
@@: cmp byte ptr flags[62],0
    je @F
    jmp nothap
    
@@: cmp byte ptr flags[29],0
    jz b3
    cmp byte ptr flags[30],0
    je @F
    jmp nothap
    
@@: mov byte ptr flags[30],1
    lea esi,ms110
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
cc: cmp al,'c'
    je @F
    cmp al,'C'
    jne pardon
    
@@: cmp byte ptr flags[62],0
    je @F
    jmp nothap
    
@@: cmp byte ptr flags[29],0
    je @F
    jmp nothap
    
@@: mov byte ptr flags[29],1
    lea esi,ms111
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
cor:
    cmp nounstore,62           ;cord
    jne otherobs
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,91
    jne nocord
    cmp byte ptr flags[16],0
    jne @F
    mov byte ptr flags[16],1
    
@@: lea esi,ms112
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; ************************************
;    OPEN   
; ************************************

open:
    cmp nounstore,36            ;tin
    jne @41
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp tin,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms113
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[35],0
    jne a1
    cmp canopener,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms114
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[35],1
    lea esi,ms115
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@41:
    cmp nounstore,30         ;bottle
    jz a2
    cmp nounstore,41         ;jar
    jz a2
    cmp nounstore,6          ;flask
    jz a2
    cmp nounstore,49         ;all
    jb cannotdo
    cmp nounstore,52         ;chest
    jne dor
    cmp location,28
    jne nochest
    cmp byte ptr flags[38],0
    je @F

a2: add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    
a1: Invoke SetTextColor,light_red,0
    lea esi,ms116
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[38],1
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    lea esi,ms117
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
dor:
    cmp nounstore,51            ;door
    jne cboard
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,50
    je @F
    cmp location,58
    jne @l4
    
@@: cmp byte ptr flags[39],0
    jne a1
    mov byte ptr flags[39],1
    lea esi,directions-1
    or byte ptr[esi+50],32
    lea esi,ms12
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl
    
@l4:
    cmp location,39
    jne @F
    cmp byte ptr flags[33],0
    jne a1
    lea esi,ms118
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,64
    je @F
    cmp location,72
    jne @27

@@: cmp byte ptr flags[26],0
    jne a1
    cmp byte ptr flags[25],0
    jne @F
    
d1: lea esi,ms119
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,directions-1
    or byte ptr[esi+64],32
    mov byte ptr flags[26],1
    lea esi,ms120
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@27:
    cmp location,75
    je @F
    cmp location,74
    jne @38
    
@@: cmp byte ptr flags[37],0
    jne a1
    cmp byte ptr flags[34],0
    jne @F
    lea esi,ms121
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[37],1
    lea esi,directions-1
    or byte ptr [esi+75],64
    lea esi,ms122
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@38:
    cmp location,99
    je @F
    cmp location,100
    jne @21
    
@@: cmp byte ptr flags[28],0
    jne a1
    cmp byte ptr flags[27],0
    jz d1
    mov byte ptr flags[28],1
    lea esi,directions-1
    or byte ptr[esi+99],128
    lea esi,ms123
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@21:
    cmp location,102
    je @F
    cmp location,94
    jne @32
    
@@: cmp byte ptr flags[65],0
    jne a1
      
a4: lea esi,ms124
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@32:
    cmp location,107
    je @F
    cmp location,108
    jne a5
    
@@: cmp byte ptr flags[40],0
    je a4
    jmp a1
    
a5: cmp location,53
    jne @F
    cmp byte ptr flags[64],0
    jne a1
    jmp a4

@@: cmp location,47
    jne @F
    cmp byte ptr flags[71],1
    je a1
    lea esi,ms125
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp location,85
    jne nodoor
    cmp byte ptr flags[72],1
    je @F
    lea esi,ms126
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: lea esi,ms127
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; -------------------------------------------------------------------------
    
cboard:
    cmp nounstore,74                   ;cupboard
    jne cannotdo
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,57
    jne @F
    cmp byte ptr flags[54],0
    je @98
    Invoke SetTextColor,light_red,0
    lea esi,ms128
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@98:
    mov byte ptr flags[54],1
    lea esi,ms129
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,88
    jne nocup
    cmp byte ptr flags[41],0
    jne a1
    lea esi,ms130
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    EXAMINE    
; ************************************

ordinairy:
    lea esi,ms131
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

examine:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov ebx,nounstore
    cmp ebx,49
    ja nonmove
    lea edi,lamp-1
    add edi,ebx
    cmp byte ptr[edi],128
    jne nhold
    cmp ebx,1
    jne @F
    cmp byte ptr flags[1],0
    jz @g
    add ebx,49
    jmp @g
    
@@: cmp ebx,9
    jne @F
    cmp byte ptr flags[17],0
    je @g
    add ebx,42
    jmp @g
    
@@: cmp ebx,27
    jne @F
    cmp byte ptr flags[56],0
    je @F
    add ebx,25
    
@@: cmp ebx,11
    jne @g
    cmp byte ptr flags[57],0
    je @g
    add ebx,42
    
@g: shl ebx,2
    lea esi,dtable-4
    mov esi,[esi+ebx]
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nonmove:                       ;non moving objects
    sub ebx,49

SWITCH ebx

    case 1
        jmp pardon
    case 2
        jmp nm2     ;door
    case 3
        jmp nm3     ;chest
    case 4
        jmp nm4     ;toadstool
    case 5
        jmp nm5     ;ring
    case 6
        jmp nm6     ;column
    case 7
        jmp nm7     ;slab
    case 8
        jmp nm8     ;logs
    case 9
        jmp nm9     ;sand
    case 10
        jmp nm10    ;reeds
    case 11
        jmp nm11    ;stones
    case 12 
        jmp nm12    ;fountain
    case 13
        jmp nm13    ;cord
    case 14 
        jmp nm14    ;lever
    case 15
        jmp nm15    ;handle
    case 16
        jmp nm16    ;music
    case 17
        jmp nm17    ;tombstone
    case 18
        jmp nm18    ;bench
    case 19
        jmp nm19    ;bear
    case 20
        jmp nm20    ;magpie
    case 21
        jmp nm21    ;sundial
    case 22
        jmp nm22    ;message
    case 23
        jmp nm23    ;hole
    case 24
        jmp nm24    ;statue
    case 25
        jmp nm25    ;cupboard
    case 26
        jmp pardon
    case 27
        jmp nm27    ;writing
    case 28 
        jmp nm28    ;painting
    case 29
        jmp nm29    ;knocker
    case 30
        jmp nm30    ;hut
    case 31
        jmp nm31    ;mirror
    case 32
        jmp nm32    ;princess/xastra
    case 33
        jmp nm33    ;inscription
    case 34
        jmp nm34    ;table
    case 35
        jmp nm35    ;bed
    case 36
        jmp nm36    ;shelves
    case 37
        jmp nm37    ;bush
    case 38
        jmp nm38    ;desk
    case 39
        jmp nm39    ;signpost
    case 40
        jmp nm40    ;sawdust
    case 41
        jmp nm41    ;water
    case 42
        jmp nm42    ;pond
    case 43
        jmp nm43    ;notice
    case 44
        jmp nm44    ;tray
    case 45
        jmp nm45    ;wall
    case 46
        jmp nm46    ;river
    case 47
        jmp nm47    ;inn
    case 48
        jmp nm48    ;path
    case 49
        jmp nm49    ;precipice
    case 50
        jmp nm50    ;chain
    case 51
        jmp nm51    ;skull
    case 52
        jmp nm52    ;straw
    case 53
        jmp nm53    ;bones
    case 54
        jmp nm54    ;drink
    case 55
        jmp nm55    ;tree
    case 56
        jmp nm56    ;lawn
    case 57
        jmp nm57    ;temple
    case 58
        jmp nm32    ;princess/xastra
    case 59
        jmp nm59    ;rhyme
    case 60
        jmp nm60    ;engraving
    case 61
        jmp nm61    ;button
    case 62
        jmp nm62    ;gunpowder
    case 63
        jmp nm63    ;torch
    case 64
        jmp nm64    ;sink
    case 65
        jmp nm65    ;tap
    case 66
        jmp nm66    ;jetty
    case 67
        jmp nm67    ;grill
    case 68
        jmp nm68    ;footprints
    case 69
        jmp nm69    ;nest
    case 70
        jmp nm70    ;couch
    case 71
        jmp nm71    ;tree
    case 72
        jmp nm72    ;lantern
    case 73
        jmp nm73    ;drawbridge
    case 74
        jmp nm74    ;brook
    case 75
        jmp nm75    ;charm
    case 76
        jmp nm76    ;window
    case 77
        jmp nm77    ;pedestal
    case 78
        jmp nm78    ;rod
    case 79
        jmp nm79    ;rack
    case 80
        jmp nm80    ;seat
    case 81
        jmp nm81    ;slot
    case 82
        jmp nm82    ;lake

    DEFAULT
        jmp pardon
ENDSW

; -------------------------------------------------------------------------
    
nm2:                      ;door
    cmp location,50
    jne @F
    lea esi,ms132
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,39
    jne @9
    
@@: lea esi,ms133
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@9: cmp location,64
    jne @F
    lea esi,ms134
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,99
    je l10
    cmp al,100
    jne @F
    
l10:
    lea esi,ms135
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,107
    jne @F
    lea esi,ms136
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL

    add rowpos,2
    jmp hifnl
    
@@: cmp location,75
    jne @F
    lea esi,ms137
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,53
    jne @F
    lea esi,ms138
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,102
    je @F
    cmp location,94
    jne @j
    
@@: lea esi,ms139
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@j: cmp location,100
    jne @F
    lea esi,ms140
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp location,47
    jne @F
    lea esi,ms141
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp location,85
    jne nodoor
    cmp byte ptr flags[72],1
    je ordinairy
    lea esi,ms142
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
  
nodoor:
    Invoke SetTextColor,light_red,0
    lea esi,ms143
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm3:                      ;chest
    cmp location,28
    jne nochest
    cmp byte ptr flags[38],0
    jne @F
    lea esi,ms144
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[42],0
    jne ordinairy
    mov byte ptr flags[42],1
    mov al,location
    mov knife,al
    mov flask,al
    mov boots,al
    mov nails,al
    mov jar,al
    lea esi,ms145
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nochest:
    Invoke SetTextColor,light_red,0
    lea esi,ms146
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm4:                      ;toadstool
    cmp location,18
    jne notoad
    lea esi,ms147
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

notoad:
    Invoke SetTextColor,light_red,0
    lea esi,ms148
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm5:                      ;ring
    cmp location,34
    jne noring
    lea esi,ms149
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

noring:
    Invoke SetTextColor,light_red,0
    lea esi,ms150
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm6:                      ;column
    cmp location,92
    jne @F
    lea esi,ms151
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,93
    jne nocol
    lea esi,ms152
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nocol:
    Invoke SetTextColor,light_red,0
    lea esi,ms153
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm7:                      ;slab
    cmp location,112
    jne noslab
    cmp byte ptr flags[32],0
    jne ordinairy
    lea esi,ms154
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

noslab:
    Invoke SetTextColor,light_red,0
    lea esi,ms155
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
 nm8:                       ;logs
    cmp location,20
    jne nologs
    cmp byte ptr flags[43],0
    jne ordinairy
    mov byte ptr flags[43],1
    mov al,location
    mov axe,al
    lea esi,ms156
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nologs:
    Invoke SetTextColor,light_red,0
    lea esi,ms157
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm9:                       ;sand
    cmp location,1
    jz ordinairy

nosand:
    Invoke SetTextColor,light_red,0
    lea esi,ms158
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm10:                      ;reeds
    cmp location,27
    jne noreeds
    cmp byte ptr flags[44],0
    jnz ordinairy
    mov byte ptr flags[44],1
    mov stem,27
    lea esi,ms159
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

noreeds:
    Invoke SetTextColor,light_red,0
    lea esi,ms160
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm11:                      ;stones
    mov ecx,4
    lea edi,stones
    mov al,location

@@: cmp al,[edi]
    jz @F
    inc edi
    dec ecx
    jne @B

nostones:
    Invoke SetTextColor,light_red,0
    lea esi,ms161
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms162
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm12:                    ;fountain
    cmp location,47
    jne nofount
    lea esi,ms163
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl 

nofount:
    Invoke SetTextColor,light_red,0
    lea esi,ms164
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
   
nm13:                    ;cord
    cmp location,91
    jne nocord
    lea esi,ms165
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nocord:
    Invoke SetTextColor,light_red,0
    lea esi,ms166
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm14:                    ;lever
    cmp location,94
    jne nolever
    lea esi,ms167
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nolever:
    Invoke SetTextColor,light_red,0
    lea esi,ms168
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm15:                    ;handle
    cmp location,45
    jne @F
    cmp byte ptr flags[1],1
    jne @76
    cmp lamp,128
    jz ordinairy
    mov al,location
    cmp lamp,al
    jz ordinairy
    
@76:
    Invoke SetTextColor,light_red,0
    lea esi,ms169
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,112
    jne @F
    cmp byte ptr flags[32],0
    jne nohandle
    lea esi,ms170
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nohandle:
    Invoke SetTextColor,light_red,0
    lea esi,ms171
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm16:                    ;music
    cmp location,67
    jne @F
    
@@1:
    lea esi,ms172
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp parchment,128
    jne nomusic
    cmp byte ptr flags[17],0
    jne @@1
    
nomusic:
    Invoke SetTextColor,light_red,0
    lea esi,ms173
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm17:                    ;tombstone
    cmp location,67
    jne @F
    lea esi,ms174
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea edi,tmbst
    mov ecx,3
    mov al,location

@@: cmp al,[edi]
    jz ordinairy
    inc edi
    dec ecx
    jne @B

notomb:
    Invoke SetTextColor,light_red,0
    lea esi,ms175
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm18:                    ;bench
    cmp location,51
    jne nobench
    cmp byte ptr flags[45],0
    jne ordinairy
    mov byte ptr flags[45],1
    mov al,location
    mov spade,al
    lea esi,ms176
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nobench:
    Invoke SetTextColor,light_red,0
    lea esi,ms177
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm19:                    ;bear
    mov al,location
    cmp al,bear
    jnz nobear

joke:
    Invoke SetTextColor,light_red,0
    lea esi,ms178
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
nobear:
    cmp location,98
    jne @F
    cmp bear,99
    je @F
    lea esi,ms179
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: Invoke SetTextColor,light_red,0
    lea esi,ms180
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm20:                    ;magpie
    mov al,location
    cmp al,magpie
    jne nomag
    lea esi,ms181
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nomag:
    Invoke SetTextColor,light_red,0
    lea esi,ms182
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; -------------------------------------------------------------------------
    
nm21:                    ;sundial
    cmp location,109
    jne nosun
    lea esi,ms183
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
nosun:
    Invoke SetTextColor,light_red,0
    lea esi,ms184
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm22:                    ;message
    cmp location,40
    jne nomess
    lea esi,ms185
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

nomess:
    Invoke SetTextColor,light_red,0
    lea esi,ms186
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm23:                    ;hole
    cmp location,45
    je ordinairy
    cmp location,91
    je ordinairy
    cmp location,112
    je ordinairy

nohole:
    Invoke SetTextColor,light_red,0
    lea esi,ms187
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm24:                    ;statue
    cmp location,110
    jne nostatue
    lea esi,ms188
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nostatue:
    Invoke SetTextColor,light_red,0
    lea esi,ms189
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm25:                    ;cupboard
    cmp location,57
    jne a7
    cmp byte ptr flags[55],0
    jne ordinairy
    cmp byte ptr flags[54],0
    je @F
    mov byte ptr flags[55],1
    mov al,location
    mov compass,al
    mov parchment,al
    lea esi,ms190
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms191
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
a7: cmp location,88
    jne nocup
    cmp byte ptr flags[41],0
    jne ordinairy
    lea esi,ms192
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nocup:
    Invoke SetTextColor,light_red,0
    lea esi,ms193
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm27:                    ;writing
    cmp location,56
    jne @F
    lea esi,ms194
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,35
    jne @F
    lea esi,ms195
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp location,42
    je @F
    cmp location,41
    je @F
    lea edi,pla
    mov ecx,4
    mov al,location

@k: cmp al,[edi]
    je lb1
    inc edi
    dec ecx
    jne @k

nowrit:
    Invoke SetTextColor,light_red,0
    lea esi,ms196
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms197
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
lb1:
    lea esi,ms198
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm28:                    ;painting
    cmp location,80
    je @F
    cmp location,79
    jne nopaint
    lea esi,ms199
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: lea esi,ms200
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nopaint:
    Invoke SetTextColor,light_red,0
    lea esi,ms201
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ------------------------------------------------------------------------
    
nm29:                    ;knocker
    cmp location,39
    jne noknock
    lea esi,ms202
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

noknock:
    Invoke SetTextColor,light_red,0
    lea esi,ms203
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm30:                    ;hut
    cmp location,5
    jne @F
    lea esi,ms204
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,6
    jne @F
    lea esi,ms205
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,95
    jne @F
    lea esi,ms206
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,96
    jne @F
    lea esi,ms207
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,20
    jz ordinairy
    cmp location,28
    jz ordinairy

nohut:
    Invoke SetTextColor,light_red,0
    lea esi,ms208
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm31:                    ;mirror
    cmp location,83
    jne nomirr
    cmp cloak,192
    je @F
    lea esi,ms209
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[56],0
    jne @F
    lea esi,ms210
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms211
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nomirr:
    Invoke SetTextColor,light_red,0
    lea esi,ms212
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm32:                    ;Princess/Xastra
    cmp location,108
    jne noprin
    lea esi,ms213
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

noprin:
    Invoke SetTextColor,light_red,0
    lea esi,ms214
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm33:                    ;inscription
    cmp location,75
    jne noinscr
    lea esi,ms215
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

noinscr:
    Invoke SetTextColor,light_red,0
    lea esi,ms216
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm34:                    ;table
    cmp location,70
    jne @F
    cmp byte ptr flags[47],0
    jnz ordinairy
    mov al,location
    mov pie,al
    mov canopener,al
    lea esi,ms217
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,86
    jne notable
    cmp byte ptr flags[48],0
    jnz ordinairy
    mov byte ptr flags[48],1
    mov al,location
    mov glasses,al
    mov thread,al
    lea esi,ms218
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

notable:
    Invoke SetTextColor,light_red,0
    lea esi,ms219
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm35:                    ;bed
    cmp location,84
    jne nobed
    cmp byte ptr flags[49],0
    jne ordinairy
    mov byte ptr flags[49],1
    mov al,location
    mov cloak,al
    lea esi,ms220
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nobed:
    Invoke SetTextColor,light_red,0
    lea esi,ms221
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm36:                    ;shelves
    cmp location,34
    jne @F
    cmp byte ptr flags[50],0
    jnz ordinairy
    mov byte ptr flags[50],1
    mov al,location
    mov lamp,al
    mov peg,al
    mov hammer,al
    mov bottle,al
    lea esi,ms222
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,46
    jne noshelves
    cmp ladder,128
    je @F
    lea esi,ms223
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[53],0
    jnz ordinairy

clilad:
    mov byte ptr flags[53],1
    mov al,location
    mov tin,al
    lea esi,ms224
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

noshelves:
    Invoke SetTextColor,light_red,0
    lea esi,ms225
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; -------------------------------------------------------------------------
    
nm37:                    ;bush
    cmp location,111
    jne nobush
    cmp byte ptr flags[52],0
    jnz ordinairy
    mov byte ptr flags[52],1
    mov al,location
    mov fruit,al
    lea esi,ms226
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nobush:
    Invoke SetTextColor,light_red,0
    lea esi,ms227
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
 
nm38:                    ;desk
    cmp location,69
    jne nodesk
    cmp byte ptr flags[51],0
    jne ordinairy
    mov byte ptr flags[51],1
    mov al,location
    mov needle,al
    mov paper,al
    lea esi,ms228
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nodesk:
    Invoke SetTextColor,light_red,0
    lea esi,ms229
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm39:                    ;signpost
    cmp location,7
    je @F
    cmp location,23
    jne nosign

@@: lea esi,ms230
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
nosign:
    Invoke SetTextColor,light_red,0
    lea esi,ms231
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl


; -------------------------------------------------------------------------
    
nm40:                    ;sawdust
    cmp location,28
    jne nosaw
    cmp byte ptr flags[63],0
    jnz ordinairy
    mov byte ptr flags[63],1
    mov al,location
    mov plank,al
    lea esi,ms232
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nosaw:
    Invoke SetTextColor,light_red,0
    lea esi,ms233
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; -------------------------------------------------------------------------
    
nm41:                    ;water
    cmp flask,128
    jne @F
    cmp byte ptr flags[21],0
    je @F
    lea esi,ms234
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: Invoke SetTextColor,light_red,0
    lea esi,ms235
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; -------------------------------------------------------------------------
    
nm42:                    ;pond
    cmp location,32
    jne nopond
    cmp byte ptr flags[3],0
    jne ordinairy
    mov byte ptr flags[3],1
    mov al,location
    mov hook,al
    lea esi,ms236
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nopond:
    Invoke SetTextColor,light_red,0
    lea esi,ms237
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; -------------------------------------------------------------------------
    
nm43:                    ;notice
    cmp location,56
    je @F
    cmp location,42
    je @F
    cmp location,35
    je @F
    cmp location,85
    jne nonotice
    cmp byte ptr flags[72],1
    je nonotice
    
@@: lea esi,ms238
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nonotice:
    Invoke SetTextColor,light_red,0
    lea esi,ms239
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm44:                    ;tray
    mov al,location
    cmp pedlar,al
    jne notray
    lea esi,ms240
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

notray:
    Invoke SetTextColor,light_red,0
    lea esi,ms241
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; -------------------------------------------------------------------------
  
nm45:                   ;wall
    mov ecx,40
    lea edi,wls
    repne scasb
    jz ordinairy

nowall:
    Invoke SetTextColor,light_red,0
    lea esi,ms242
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm46:                   ;river
    cmp location,27
    je ordinairy
    cmp location,35
    je ordinairy
    cmp location,43
    je ordinairy

noriver:
    Invoke SetTextColor,light_red,0
    lea esi,ms243
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm47:                   ;inn
    cmp location,42
    je ordinairy
    cmp location,43
    je ordinairy

noinn:
    Invoke SetTextColor,light_red,0
    lea esi,ms244
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm48:                   ;path
    mov ecx,16
    lea edi,phs
    repne scasb
    jz ordinairy

nopath:
    Invoke SetTextColor,light_red,0
    lea esi,ms245
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm49:                   ;precipice
    cmp location,11
    je @F
    cmp location,12
    jne noprec
    
@@: lea esi,ms246
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

noprec:
    Invoke SetTextColor,light_red,0
    lea esi,ms247
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm50:                   ;chain
    cmp location,45
    jne nochain
    cmp byte ptr flags[1],0
    jne @F
    
cd: lea esi,ms248
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
       
@@: cmp lamp,128
    je @F
    mov al,location
    cmp al,lamp
    jne cd
    
@@: lea esi,ms249
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nochain:
    Invoke SetTextColor,light_red,0
    lea esi,ms250
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; -------------------------------------------------------------------------
    
nm51:                   ;skull
    cmp location,64
    je ordinairy

noskull:
    Invoke SetTextColor,light_red,0
    lea esi,ms251
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm52:                   ;straw
    cmp location,65
    jne nostraw
    cmp byte ptr flags[67],0
    jne ordinairy
    mov byte ptr flags[67],1
    mov al,location
    mov scroll,al
    lea esi,ms252
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nostraw:
    Invoke SetTextColor,light_red,0
    lea esi,ms253
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm53:                   ;bones
    cmp location,65
    jne nobones
    lea esi,ms254
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nobones:
    Invoke SetTextColor,light_red,0
    lea esi,ms255
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
 
; -------------------------------------------------------------------------
    
nm54:                   ;drink
    lea esi,ms256
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm55:                   ;tree
    mov ecx,10
    lea edi,trees
    mov al,location

@@: cmp al,[edi]
    je ordinairy
    inc edi
    dec ecx
    jne @B

notree:
    Invoke SetTextColor,light_red,0
    lea esi,ms257
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm56:                   ;lawn
    cmp location,31
    jz ordinairy

nolawn:
    Invoke SetTextColor,light_red,0
    lea esi,ms258
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm57:                   ;temple
    cmp location,104
    je ordinairy
    cmp location,112
    je ordinairy

notemp:
    Invoke SetTextColor,light_red,0
    lea esi,ms259
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm59:                   ;rhyme
    cmp scroll,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms260
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms261
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm60:                   ;engraving
    cmp paper,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms262
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms263
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm61:                   ;button
    cmp location,109
    jne nobut
    lea esi,ms264
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nobut:
    Invoke SetTextColor,light_red,0
    lea esi,ms265
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm62:                   ;gunpowder
    cmp keg,128
    je @F
    Invoke SetTextColor,light_red,0
    jmp nokeg
    
@@: lea esi,ms266
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm63:                   ;torch
    cmp location,83
    jz ordinairy

notorch:
    Invoke SetTextColor,light_red,0
    lea esi,ms267
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm64:                   ;sink
    cmp location,96
    jz ordinairy

nosink:
    Invoke SetTextColor,light_red,0
    lea esi,ms268
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm65:                    ;tap
    cmp location,96
    jz ordinairy

notap:
    Invoke SetTextColor,light_red,0
    lea esi,ms269
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm66:                    ;jetty
    cmp location,35
    jne nojet
    lea esi,ms270
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nojet:
    Invoke SetTextColor,light_red,0
    lea esi,ms271
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
nm67:                    ;grill
    cmp location,98
    jne nogrill
    cmp bear,99
    jz ordinairy
    lea esi,ms272
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nogrill:
    Invoke SetTextColor,light_red,0
    lea esi,ms273
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; -------------------------------------------------------------------------
    
nm68:                    ;footprints
    cmp location,1
    jne nofp
    lea esi,ms274
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nofp:
    Invoke SetTextColor,light_red,0
    lea esi,ms275
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm69:                    ;nest
    cmp location,93
    jne nonest
    cmp byte ptr flags[70],0
    jne ordinairy
    mov byte ptr flags[70],1
    mov gloves,93
    lea esi,ms276
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nonest:
    Invoke SetTextColor,light_red,0
    lea esi,ms277
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm70:                   ;couch
    cmp location,108
    jne nocouch
    lea esi,ms278
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nocouch:
    Invoke SetTextColor,light_red,0
    lea esi,ms279
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm71:
    mov ecx,10        ;ten locations
    lea edi,trees
    mov al,location

@@: cmp al,[edi]
    jz ordinairy
    inc edi
    dec ecx
    jne @B
    
nobra:
    Invoke SetTextColor,light_red,0
    lea esi,ms280
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm72:                  ;lantern
    cmp location,77
    jne nolant
    lea esi,ms281
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nolant:
    Invoke SetTextColor,light_red,0
    lea esi,ms282
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm73:                   ;drawbridge
    cmp location,102
    jne @F
    cmp byte ptr flags[62],1
    jne drawup
    
@N: lea esi,ms283
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp location,103
    je @N

nodraw:
    Invoke SetTextColor,light_red,0
    lea esi,ms284
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm74:                    ;brook
    cmp location,6
    jne nobrook
    lea esi,ms285
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

nobrook:
    Invoke SetTextColor,light_red,0
    lea esi,ms286
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm75:                     ;charm
    cmp charm,128
    jne nhold
    lea esi,ms287
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm76:                     ;window
    cmp location,79
    jne @F
    lea esi,ms288
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp location,36
    jz ordinairy
    cmp location,106
    jz ordinairy

nowin:
    Invoke SetTextColor,light_red,0
    lea esi,ms289
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm77:                     ;pedestal
    cmp location,64
    je @F

noped:
    Invoke SetTextColor,light_red,0
    lea esi,ms290
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: lea esi,ms291
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm78:                     ;rod
    cmp location,64
    je @F

norod:
    Invoke SetTextColor,light_red,0
    lea esi,ms292
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: lea esi,ms293
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm79:                     ;rack
    cmp location,71
    je ordinairy

norack:
    Invoke SetTextColor,light_red,0
    lea esi,ms294
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm80:                     ;seat
    cmp location,111
    je ordinairy

noseat:
    Invoke SetTextColor,light_red,0
    lea esi,ms295
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm81:                     ;slot
    cmp location,99
    je ordinairy

noslot:
lea esi,ms534
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    lea esi,ms296
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

nm82:
    mov ecx,3             ;3 locations
    lea edi,lac
    mov al,location

@@: cmp al,[edi]
    jz @F
    inc edi
    dec ecx
    jne @B

nolak:
    Invoke SetTextColor,light_red,0
    lea esi,ms535
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: lea esi,ms534
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    CLIMB   
; ************************************

climb:
    cmp nounstore,26    ;ladder
    jne rock
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp ladder,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms297
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,46
    cmp byte ptr flags[53],0
    jz clilad
    lea esi,ms298
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
rock:
    cmp nounstore,55     ;column
    jne treee
    cmp location,92
    je @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    jmp nocol

@@: cmp rope,128
    jne noquip
    cmp hook,128
    jne noquip
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms299
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    mov location,93
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

treee:
    cmp nounstore,104
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov ecx,10                  ;ten locations
    lea edi,trees
    mov al,location

@@: cmp al,[edi]
    jz @F
    inc edi
    dec ecx
    jne @B
    jmp notree

@@: lea esi,ms300
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    GIVE    
; ************************************

give:
    cmp nounstore,12      ;stick
    jne money
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp stick,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms301
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp oldman,10
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms302
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov oldman,0
    mov stick,0
    dec carry
    mov byte ptr flags[4],1
    mov amulet,10
    lea esi,ms13
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

; -------------------------------------------------------------------------
    
money:
    cmp nounstore,4       ;coin
    jne flt
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp coin,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms303
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov al,location
    cmp gravedigger,al
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms304
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: inc carry
    mov gravedigger,0
    mov pen,128
    mov byte ptr flags[7],1
    lea esi,ms14
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

; -------------------------------------------------------------------------
    
flt:
    cmp nounstore,24        ;flute
    jne crd
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp flute,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms305
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,53
    je @F
    
@19:
    Invoke SetTextColor,light_red,0
    lea esi,ms306
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp jailer,53
    jne @19
    mov jailer,0
    mov flute,0
    dec carry
    mov byte ptr flags[64],1
    lea esi,ms15
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

; -------------------------------------------------------------------------
    
crd:
    cmp nounstore,49        ;card
    jne pgs
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp card,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms307
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov al,location
    cmp butler,al
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms308
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: dec carry
    mov card,0
    mov butler,0
    lea esi,ms309
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
pgs:
    cmp nounstore,44         ;pegs
    jne @l7
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    mov al,location
    cmp gypsy,al
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms310
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp peg,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms311
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov gypsy,0
    mov peg,0
    mov charm,128
    mov byte ptr flags[11],1
    lea esi,ms17
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

; -------------------------------------------------------------------------
    
@l7:
    cmp nounstore,49
    ja nhold
    lea esi,lamp-1
    xchg ebx,ecx
    cmp byte ptr[esi+ebx],128
    jne nhold
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    lea esi,ms312
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    PLAY    
; ************************************

play:
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp nounstore,65          ;music
    jne @F
    cmp location,67
    jne @m
    cmp flute,128
    je nothap
    Invoke SetTextColor,light_red,0
    lea esi,ms313
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp nounstore,24           ;flute
    je @m
    cmp nounstore,64
    jne cannotdo
    
@m: cmp flute,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms314
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp parchment,128
    je @F
    
@94:
    Invoke SetTextColor,light_red,0
    lea esi,ms315
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[17],0
    je @94
    cmp location,18
    jne nothap
    cmp byte ptr flags[2],0
    jne nothap
    mov byte ptr flags[2],1
    lea esi,ms16
    movzx ecx,word ptr[esi]
    add esi,2
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,5
    jmp hifnl

; ************************************
;    LOAD    
; ************************************

load:
    cmp nounstore,32
    jne cannotdo
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp gun,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms316
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[24],0
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms317
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp charm,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms318
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp keg,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms319
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[24],1
    dec carry
    mov charm,0
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    SHOOT   
; ************************************

shoot:
    cmp nounstore,68     ;bear
    jne cannotdo
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    mov al,location
    cmp bear,al
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms320
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp gun,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms321
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp byte ptr flags[24],0
    jne @F
    lea esi,ms322
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov bear,0
    mov byte ptr flags[15],1
    mov disc,al
    dec byte ptr flags[24]
    lea esi,ms323
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

; ************************************
;    UNLOCK  
; ************************************

unlock:
    cmp nounstore,51     ;door
    jne chest
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,64
    jne @62
    cmp byte ptr flags[25],0
    je @F
    
@84:
    lea esi,ms324
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp key,128
    je @F
    
nk: Invoke SetTextColor,light_red,0
    lea esi,ms325
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[25],1
    lea esi,ms326
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@62:
    cmp location,99
    je @F
    cmp location,85
    jne ndr
    cmp byte ptr flags[72],1
    je dunl
    lea esi,ms325
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

dunl:
    lea esi,ms324
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

ndr:
    Invoke SetTextColor,light_red,0
    lea esi,ms327
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[27],0
    jne @84
    cmp disc,128
    je @F
    cmp key,128
    jne nk
    lea esi,ms328
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
havdsk:
    mov byte ptr flags[27],1
    mov disc,0
    lea esi,ms329
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
chest:
    cmp nounstore,52     ;chest
    jne @F
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    Invoke SetTextColor,light_red,0
    lea esi,ms330
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
@@: cmp nounstore,74      ;cupboard
    jne cannotdo
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    Invoke SetTextColor,light_red,0
    lea esi,ms331
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    KISS    
; ************************************

kiss:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp nounstore,81      ;princess
    je @F
    cmp nounstore,107     ;xastra
    je @F
    jmp pardon
@@: cmp location,108
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms332
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cls
    call hidecursor
    loc 0,0
    mov edx,1
    mov cow,56
    
@@: push edx
    invoke SetScreenColor,0,edx
    cls
    pop edx
    cmp edx,15
    jne @cn
    sub edx,edx
    
@cn:inc edx
    push edx
    invoke Sleep,15
    pop edx
    dec cow
    jne @B
    cls
    invoke SetScreenColor,0,0
    Invoke SetTextColor,yellow,0
    loc 2,2
    lea esi,ms18
    movzx ecx,word ptr[esi]
    add esi,2
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,12
    movzx ecx,rowpos
    loc 27,ecx
    Invoke SetTextColor,light_green,0
    invoke Sleep,5000
    lea esi,ms530
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,6
    movzx ecx,rowpos
    loc 27,ecx
    Invoke SetTextColor,light_cyan,0
    lea esi,ms531
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    getkey
    call showcursor
    ret
    
; ************************************
;   GREASE   
; ************************************

grease:
    cmp nounstore,51      ;door
    jne cannotdo
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp location,75
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms333
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[34],0
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms334
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp tin,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms335
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[35],0
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms336
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[34],1
    lea esi,ms337
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;   USE  
; ************************************

use:
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    cmp nounstore,10      ;compass
    jne chopper
    cmp compass,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms338
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov ecx,24
    lea edi,isle
    repne scasb
    jz round
    cmp location,67
    ja circle
    cmp location,29
    je @F
    lea esi,ms339
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp compoint,0
    jne @F
    inc compoint
    
ps: lea esi,ms340
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp compoint,2
    je @F
    inc compoint
    lea esi,ms341
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: dec compoint
    jmp ps

round:
    lea esi,ms342
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

chopper:
    cmp nounstore,37       ;axe
    jne gpow
    cmp location,88
    jne todowat
    cmp byte ptr flags[41],0
    jne todowat
    mov byte ptr flags[41],1
    mov gun,88
    lea esi,ms343
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
gpow:
    cmp nounstore,111      ;gunpowder
    jne @F
    cmp keg,128
    je todowat
    Invoke SetTextColor,light_red,0
    lea esi,ms344
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp nounstore,49
    ja cannotdo
    mov ebx,nounstore
    lea esi,lamp-1
    cmp byte ptr[esi+ebx],192
    je @F
    cmp byte ptr[esi+ebx],128
    jne nhold
    
todowat:
    lea esi,ms345
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    WEAR   
; ************************************
    
wear:
    cmp nounstore,18       ;helmet
    jne amlet
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp helmet,192
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms346
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp helmet,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms347
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
 
@@: cmp cloak,192
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms348
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: inc worn
    dec carry
    mov helmet,192
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
amlet:
    cmp nounstore,19       ;amulet
    jne cloke
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp amulet,192
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms349
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp amulet,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms350
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: inc worn
    dec carry
    mov amulet,192
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
cloke:
    cmp nounstore,27       ;cloak
    jne shoes
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp cloak,192
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms351
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp cloak,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms352
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
 
@@: cmp helmet,192
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms353
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: inc worn
    dec carry
    mov cloak,192
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
shoes:
    cmp nounstore,38       ;boots
    jne specs
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp boots,192
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms354
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp boots,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms355
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[20],0
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms356
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: inc worn
    dec carry
    mov boots,192
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
specs:
    cmp nounstore,42       ;spectacles
    jne glves
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp glasses,192
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms357
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp glasses,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms358
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: inc worn
    dec carry
    mov glasses,192
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
glves:                     ;gloves
    cmp nounstore,16
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp gloves,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms359
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp gloves,192
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms360
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: inc worn
    dec carry
    mov gloves,192
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;     BUY    
; ************************************

buy:
    cmp nounstore,2          ;matches ?
    jne bd                   ;no, goto bread
    cmp byte ptr flags[5],0
    jne already
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov al,location
    cmp landlord,al
    jne @F
    lea esi,ms361
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp pedlar,al
    je @F
    
noone:
    lea esi,ms362
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp gold,128
    jne @F
    lea esi,ms363
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp coin,128
    je @F
    
nomoney:
    Invoke SetTextColor,light_red,0
    lea esi,ms364
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov pedlar,0
    mov matches,128
    inc carry
    mov byte ptr flags[5],1
    mov byte ptr flags[9],0
    lea esi,ms365
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
bd: cmp nounstore,20         ;bread ?
    jne dk                   ;no, goto drink
    cmp bread,128            ;already carrying bread?
    je already               ;if yes exit routine
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov al,location
    cmp landlord,al          ;is landlord present?
    jne noone                ;no, goto no one here
    cmp gold,128             ;carring gold piece?
    jne @F                   ;no, goto coin
    mov gold,0               ;delete gold piece
    mov bread,128            ;carry bread
    mov coin,128             ;carry coins
    inc carry                ;objects carried = objects carried + 1
    lea esi,ms20
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp coin,128
    jne nomoney
    mov bread,128
    inc carry
    lea esi,ms21
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
dk: cmp nounstore,103        ;drink ?
    jne lac                  ;no, go to laces
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov al,location
    cmp landlord,al          ;current location ?
    jne noone                ;no, goto no one selling here
    cmp gold,128             ;yes, carrying gold
    jne @F                   ;no, goto coins
    cmp ale,0                ;first drink ?
    jne @13                  ;no, no goto test how many
    inc ale                  ;drink = drink + 1
    add thirsty,7            ;add 7 to needing drink
    mov gold,0               ;get rid of gold
    mov coin,128             ;replace with coins
    lea esi,ms22
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl
    
@@: cmp coin,128              ;carrying coins ?
    jne nomoney               ;no, goto no money
    cmp ale,0
    jne @13
    inc ale
    add thirsty,7
    lea esi,ms23
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl
    
@13: 
    cmp ale,1                 ;second drink ?
    ja @F                     ;no, goto third
    inc ale
    mov drunk,6
    lea esi,ms24
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl
    
@@: lea esi,ms25
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,8000
    jmp fail

; -------------------------------------------------------------------------
    
lac:
    cmp nounstore,40            ;laces
    jne cannotdo
    cmp byte ptr flags[61],0
    jne already
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov al,location
    cmp pedlar,al
    jne noone
    cmp gold,128
    jne @f
    lea esi,ms363
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    cmp coin,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms366
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[61],1
    mov byte ptr flags[9],0 
    inc carry
    mov laces,128
    mov pedlar,0
    lea esi,ms367
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
; ************************************
;    WRITE   
; ************************************

wrte:
    cmp nounstore,65          ;music
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp byte ptr flags[17],0
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms368
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp pen,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms369
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[23],0
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms370
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp parchment,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms371
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,67
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms372
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[17],1
    lea esi,ms373
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;  INSERT  
; ************************************

insert:
    cmp nounstore,17
    je @F
    cmp nounstore,28
    jne cannotdo
    cmp location,112
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms540
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp disc,128
    je havdsk
    cmp ruby,128
    je @f
    Invoke SetTextColor,light_red,0
    lea esi,ms374
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,112
    je @F
    lea esi,ms375
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov ruby,0
    dec carry
    inc byte ptr flags[19]
    lea esi,ms376
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

; ************************************
;    DIG   
; ************************************

dig:
    cmp nounstore,58             ;sand
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp location,1
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms377
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp lamp,128
    je @F
    cmp lamp,1
    je @F
    
@80:
    Invoke SetTextColor,light_red,0
    lea esi,ms378
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[1],0
    je @80
    cmp spade,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms379
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[22],0
    je @F
    lea esi,ms380
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[22],1
    mov stick,1
    lea esi,ms381
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;   FILL  
; ************************************

fill:
    cmp nounstore,6             ;flask
    jne lmp
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp flask,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms382
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[21],0
    je @F
    lea esi,ms383
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,27
    je @F
    cmp location,35
    je @F
    cmp location,43
    jne @75
    
@@: mov byte ptr flags[21],1
    lea esi,ms384
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@75:
    cmp location,21
    je @F
    cmp location,29
    je @F
    cmp location,37
    jne @77
    
@@: lea esi,ms385
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@77:
    cmp location,32
    jne @F
    lea esi,ms386
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,96
    jne @F
    mov byte ptr flags[21],1
    lea esi,ms387
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,47
    jne @F
    mov byte ptr flags[21],1
    lea esi,ms388
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp location,6
    jne @F
    mov byte ptr flags[21],1
    lea esi,ms389
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: Invoke SetTextColor,light_red,0
    lea esi,ms390
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
lmp:
    cmp nounstore,1               ;lamp
    jne pn
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp lamp,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms391
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[60],0
    je @F
    cmp byte ptr flags[60],2
    jne @F
    cmp jar,128
    jne @95
    lea esi,ms392
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@95:
    Invoke SetTextColor,light_red,0
    lea esi,ms393
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp jar,128
    jne @95
    cmp lit,11
    jl @F
    lea esi,ms394
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[60],1
    add lit,85
    lea esi,ms395
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
pn: cmp nounstore,8               ;pen
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp pen,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms396
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[23],0
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms397
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp bottle,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms398
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[23],1
    lea esi,ms399
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    BREAK   
; ************************************

break:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp nounstore,51              ;door
    jne cpd
    mov ecx,10
    lea edi,wayin
    repne scasb
    jz nodoor
    
ts: lea esi,ms400
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
cpd:
    cmp nounstore,74              ;cupboard
    jne mrr
    cmp location,88
    je @F
    cmp location,57
    je @99
    jmp nocup
    
@@: cmp byte ptr flags[41],0
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms401
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: print "How?"
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
mrr:
    cmp nounstore,80              ;mirror
    jne grl
    cmp location,83
    jne nomirr
    lea esi,ms402
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,5000
    jmp fail

; -------------------------------------------------------------------------
    
grl:
    cmp nounstore,116              ;grill
    jne @99
    cmp location,98
    je ts
    jmp nogrill
    
@99:
    lea esi,ms403
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;     LACE   
; ************************************

lace:
    cmp nounstore,38                ;boots
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp byte ptr flags[20],0
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms404
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp boots,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms405
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp laces,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms406
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov laces,0
    mov byte ptr flags[20],1
    dec carry
    lea esi,ms529
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;     KILL   
; ************************************

kill:

add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp nounstore,68                  ;bear
    je @F
    lea esi,ms407
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov al,location
    cmp bear,al
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms408
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms409
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    DRINK   
; ************************************

drink:
    cmp nounstore,90                    ;water
    jne cannotdo
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp flask,128
    je @F
    
tt: Invoke SetTextColor,light_red,0
    lea esi,ms410
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[21],0
    je tt
    cmp thirsty,25
    jb @F
    lea esi,ms411
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[21],0
    mov thirsty,65
    lea esi,ms412
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;    THROW   
; ************************************

throw:
    cmp nounstore,28
    jne drop
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp crystal,128
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms413
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp location,103
    jne drop
    cmp magpie,103
    jne drop
    dec carry
    mov byte ptr flags[14],1
    mov magpie,0
    mov crystal,0
    mov ruby,103
    lea esi,ms414
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    jmp hifnl

; ************************************
;     SEW    
; ************************************

sew:
    cmp nounstore,27                  ;cloak
    jne cannotdo
    
sewing:
    cmp byte ptr flags[56],0
    jne already
    cmp cloak,192
    jne @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms415
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: cmp cloak,128
    je @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    lea esi,ms416
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp thread,128
    jne noquip
    cmp needle,128
    jne noquip
    mov byte ptr flags[56],1
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms417
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;     REPAIR/MEND    
; ************************************

repairmend:
    cmp nounstore,27            ;Cloak
    je sewing
    cmp nounstore,11            ;boat
    je @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms418
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp boat,128
    je @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    lea esi,ms419
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[57],0
    jne already
    cmp hammer,128
    jne noquip
    cmp nails,128
    jne noquip
    mov byte ptr flags[57],1
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms420
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;   TURN   
; ************************************

turn:
    cmp nounstore,100                 ;skull
    jne sdial
    cmp location,64
    je @F
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    lea esi,ms421
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[66],0
    jne nothap
    mov byte ptr flags[66],1
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms422
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
sdial:
    cmp nounstore,70                  ;sundial
    jne tp
    cmp location,109
    jne nosun
    cmp byte ptr flags[65],0
    jne nothap
    cmp byte ptr flags[46],0
    jne @f
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms423
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: mov byte ptr flags[65],1
    lea esi,directions-1
    or byte ptr [esi+102],16
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms424
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
tp: cmp nounstore,114                    ;tap
    jne @F
    cmp location,96
    je @87

nottap:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_red,0
    lea esi,ms425
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    add rowpos,2
    jmp hifnl
    
@87:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms426
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp nounstore,49
    ja cannotdo
    lea esi,lamp-1
    mov ebx,nounstore
    cmp byte ptr[esi+ebx],128
    jne nothap
    jmp nhold

; ************************************
;   SWIM   
; ************************************

swim:
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    cmp  nounstore,95
    jne lake
    mov ecx,5
    lea edi,riv
    mov al,location

@@: cmp al,[edi]
    jz @F
    inc edi
    dec ecx
    jne @B
    Invoke SetTextColor,light_red,0
    lea esi,ms243
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

@@: lea esi,ms532
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

lake:
    cmp nounstore,131
    jne pond
    mov ecx,3
    lea edi,lak
    mov al,location

@@: cmp al,[edi]
    jz @F
    inc edi
    dec ecx
    jne @B
    jmp nolak

@@: lea esi,ms533
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

pond:
    cmp nounstore,91
    jne cannotdo
    cmp location,32
    jne nopond
    lea esi,ms536
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; ************************************
;       OTHER OBJECTS     
; ************************************

otherobs:
    add rowpos,2
    movzx ebx,rowpos
    loc 0,ebx
    mov ebx,nounstore
    cmp ebx,49                ;is it a moveable object ?
    ja @F                     ;no, goto non move
    lea edi,lamp-1
    cmp byte ptr[edi+ebx],128
    je nothap
    jmp nhold
    
@@: sub ebx,49
    
SWITCH ebx

    case 1
        jmp pardon
    case 2
        jmp mob2
    case 3
        jmp mob3
    case 4
        jmp mob4
    case 5
        jmp mob5
    case 6
        jmp mob6
    case 7
        jmp mob7
    case 8
        jmp mob8
    case 9
        jmp mob9
    case 10
        jmp mob10
    case 11
        jmp mob11
    case 12 
        jmp mob12
    case 13
        jmp mob13
    case 14 
        jmp mob14
    case 15
        jmp mob15
    case 16
        jmp pardon
    case 17
        jmp mob17
    case 18
        jmp mob18
    case 19
        jmp mob19
    case 20
        jmp mob20
    case 21
        jmp mob21
    case 22
        jmp pardon
    case 23
        jmp pardon
    case 24
        jmp mob24
    case 25
        jmp mob25
    case 26
        jmp pardon
    case 27
        jmp pardon
    case 28 
        jmp mob28
    case 29
        jmp mob29
    case 30
        jmp mbs
    case 31
        jmp mob31
    case 32
        jmp mob32
    case 33
        jmp pardon
    case 34
        jmp mob34
    case 35
        jmp mob35
    case 36
        jmp mob36
    case 37
        jmp mob37
    case 38
        jmp mob38
    case 39
        jmp mob39
    case 40
        jmp pardon
    case 41
        jmp pardon
    case 42
        jmp pardon
    case 43
        jmp mob43
    case 44
        jmp mob44
    case 45
        jmp mob45
    case 46
        jmp pardon
    case 47
        jmp pardon
    case 48
        jmp pardon
    case 49
        jmp pardon
    case 50
        jmp mob50
    case 51
        jmp mob51
    case 52
        jmp pardon
    case 53
        jmp pardon
    case 54
        jmp pardon
    case 55
        jmp mob55
    case 56
        jmp pardon
    case 57
        jmp pardon
    case 58
        jmp pardon
    case 59
        jmp pardon
    case 60
        jmp pardon
    case 61
        jmp nbt
    case 62
        jmp pardon
    case 63
        jmp mob63
    case 64
        jmp mob64
    case 65
        jmp mob65
    case 66
        jmp mob66
    case 67
        jmp mob67
    case 68
        jmp mob68
    case 69
        jmp mob69
    case 70
        jmp mob70
    case 71
        jmp mob71
    case 72
        jmp mob72
    case 73
        jmp mob73
    case 74
        jmp pardon
    case 75
        jmp pardon
    case 76
        jmp pardon
    case 77
        jmp mob77
    case 78
        jmp mob78
    case 79
        jmp mob79
    case 80
        jmp mob80
    case 81
        jmp mob81        

    DEFAULT
        jmp pardon
ENDSW

; -------------------------------------------------------------------------

mob2:                      ;door
    mov ecx,10
    lea edi,wayin
    mov al,location
    
@@: cmp al,[edi]
    jz nothap
    inc edi
    dec ecx
    jne @B
    jmp nodoor

; -------------------------------------------------------------------------
    
mob3:                      ;chest
    cmp location,28
    jz nothap
    jmp nochest

; -------------------------------------------------------------------------
    
mob4:                      ;toadstool
    cmp location,18
    jz nothap
    jmp notoad

; -------------------------------------------------------------------------
    
mob5:                      ;ring
    cmp location,34
    jz nothap
    jmp noring

; -------------------------------------------------------------------------
    
mob6:                      ;column
    cmp location,92
    jz nothap
    cmp location,93
    jz nothap
    jmp nocol

; -------------------------------------------------------------------------
    
mob7:                      ;slab
    cmp location,112
    jz nothap
    jmp noslab

; -------------------------------------------------------------------------
    
mob8:                      ;logs
    cmp location,20
    jz nothap
    jmp nologs

; -------------------------------------------------------------------------
    
mob9:                      ;sand
    cmp location,1
    jz nothap
    jmp nosand

; -------------------------------------------------------------------------
    
mob10:                     ;reeds
    cmp location,27
    jz nothap
    jmp noreeds

; -------------------------------------------------------------------------
    
mob11:                     ;stones
    mov ecx,4
    lea edi,stones
    mov al,location
    
@@: cmp al,[edi]
    jz nothap
    inc edi
    dec ecx
    jne @B
    jmp nostones

; -------------------------------------------------------------------------
    
mob12:                     ;fountain
    cmp location,47
    jz nothap
    jmp nofount

; -------------------------------------------------------------------------
    
mob13:                     ;cord
    cmp location,91
    jz nothap
    jmp nocord

; -------------------------------------------------------------------------
    
mob14:                     ;lever
    cmp location,94
    jz nothap
    jmp nolever

; -------------------------------------------------------------------------
    
mob15:                     ;handle
    cmp location,45
    jne @64
    cmp byte ptr flags[1],0
    jne @55
    
@@: lea esi,ms427
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@55:
    cmp lamp,128
    jz nothap
    mov al,location
    cmp al,lamp
    jne @B
    
@64:
    cmp location,112
    jne nolever
    cmp byte ptr flags[32],0
    jne nolever
    jmp nothap

; -------------------------------------------------------------------------
    
mob17:                     ;tombstone
    mov ecx,4
    lea edi,tmbst
    mov al,location

@@: cmp al,[edi]
    jz nothap
    inc edi
    dec ecx
    jne @B
    jmp notomb

; -------------------------------------------------------------------------
    
mob18:                     ;bench
    cmp location,51
    jz nothap
    jmp nobench

; -------------------------------------------------------------------------
    
mob19:                     ;bear
    mov al,location
    cmp al,bear
    jne nobear
    jmp joke

; -------------------------------------------------------------------------
    
mob20:                     ;magpie
    mov al,location
    cmp al,magpie
    jne nomag
    lea esi,ms428
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
mob21:                     ;sundial
    cmp location,109
    jz nothap
    jmp nosun

; -------------------------------------------------------------------------
    
mob24:                     ;statue
    cmp location,110
    jz nothap
    jmp nostatue

; -------------------------------------------------------------------------
    
mob25:                     ;cupboard
    cmp location,57
    jz nothap
    cmp location,88
    jz nothap
    jmp nocup

; -------------------------------------------------------------------------
    
mob28:                     ;painting
    cmp location,80
    jz nothap
    cmp location,79
    jz nothap
    jmp nopaint

; -------------------------------------------------------------------------
    
mob29:                     ;knocker
    cmp location,39
    jz nothap
    jmp noknock

; -------------------------------------------------------------------------
    
mbs:                       ;hut
    mov ecx,6              ;six locations
    lea edi,cabin
    mov al,location

@@: cmp al,[edi]
    jz nothap
    inc edi
    dec ecx
    jne @B
    jmp nohut

; -------------------------------------------------------------------------
    
mob31:                     ;mirror
    cmp location,83
    jz nothap
    jmp nomirr

; -------------------------------------------------------------------------
    
mob32:                     ;princess
    cmp location,108
    jz nothap
    jmp noprin

; -------------------------------------------------------------------------
    
mob34:                     ;table
    cmp location,86
    jz nothap
    cmp location,70
    jz nothap
    jmp notable

; -------------------------------------------------------------------------
    
mob35:                     ;bed
    cmp location,84
    jz nothap
    jmp nobed

; -------------------------------------------------------------------------
    
mob36:                     ;shelves
    cmp location,34
    jz nothap
    cmp location,46
    jne noshelves
    cmp ladder,128
    jz nothap
    lea esi,ms429
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
mob37:                     ;bush
    cmp location,111
    jz nothap
    jmp nobush

; -------------------------------------------------------------------------
    
mob38:                     ;desk
    cmp location,69
    jz nothap
    jmp nodesk

; -------------------------------------------------------------------------
    
mob39:                     ;signpost
    cmp location,7
    jz nothap
    cmp location,23
    jz nothap
    jmp nosign

; -------------------------------------------------------------------------
    
mob43:                     ;notice
    cmp location,42
    jz nothap
    jmp nosign

; -------------------------------------------------------------------------
    
mob44:                     ;tray
    mov al,location
    cmp al,pedlar
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms430
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: lea esi,ms431
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------
    
mob45:                     ;wall
    mov ecx,40
    lea edi,wls
    mov al,location

@@: cmp al,[edi]
    jz nothap
    inc edi
    dec ecx
    jne @B
    jmp nowall

; -------------------------------------------------------------------------
    
mob50:                     ;chain
    cmp location,45
    je @F
    Invoke SetTextColor,light_red,0
    lea esi,ms432
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp byte ptr flags[1],0
    jne @F
    
@33:
    Invoke SetTextColor,light_red,0
    lea esi,ms433
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl
    
@@: cmp lamp,128
    jz nothap
    mov al,location
    cmp al,lamp
    jne @33
    jmp nothap

; -------------------------------------------------------------------------
    
mob51:                     ;skull
    cmp location,64
    jz nothap
    jmp noskull

; -------------------------------------------------------------------------
    
mob55:                     ;tree
    mov ecx,10             ;ten locations
    lea edi,trees
    mov al,location

@@: cmp al,[edi]
    jz nothap
    inc edi
    dec ecx
    jne @B
    jmp notree

; -------------------------------------------------------------------------
    
nbt:                       ;button
    cmp location,109
    jz nothap
    Invoke SetTextColor,light_red,0
    jmp nobut

; -------------------------------------------------------------------------
    
mob63:                     ;torch
    cmp location,83
    jz nothap
    jmp notorch

; -------------------------------------------------------------------------
    
mob64:                     ;sink
    cmp location,96
    jz nothap
    jmp nosink

; -------------------------------------------------------------------------
    
mob65:                     ;tap
    cmp location,96
    jz nothap
    jmp nottap

; -------------------------------------------------------------------------
    
mob66:                     ;jetty
    cmp location,35
    jz nothap
    Invoke SetTextColor,light_red,0
    jmp nojet

; -------------------------------------------------------------------------
    
mob67:                     ;grill
    cmp location,98
    jz nothap
    jmp nogrill

; -------------------------------------------------------------------------
    
mob68:                     ;footprints
    cmp location,1
    jz nothap
    jmp nofp

; -------------------------------------------------------------------------

mob69:                      ;nest
    cmp location,93
    jz nothap
    jmp nonest

; -------------------------------------------------------------------------

mob70:                      ;couch
    cmp location,108
    jz nothap
    jmp nocouch

; -------------------------------------------------------------------------

mob71:                       ;tree
    mov ecx,10
    lea edi,trees
    mov al,location

@@: cmp al,[edi]
    jz nothap
    inc edi
    dec ecx
    jne @B
    jmp nobra

; -------------------------------------------------------------------------

mob72:                       ;lantern
    cmp location,77
    jne nolant
    lea esi,ms434
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    jmp hifnl

; -------------------------------------------------------------------------

mob73:                        ;drawbridge
    cmp location,102
    je nothap
    cmp location,103
    jne nodraw
    jmp nothap

; -------------------------------------------------------------------------

mob77:                        ;pedestal
    cmp location,64
    jz nothap
    jmp noped
    
; -------------------------------------------------------------------------

mob78:                        ;rod
    cmp location,64
    jz nothap
    jmp norod
    
; -------------------------------------------------------------------------

mob79:                        ;rack
    cmp location,71
    jz nothap
    jmp norack

; -------------------------------------------------------------------------

mob80:                        ;seat
    cmp location,111
    jz nothap
    jmp noseat

; -------------------------------------------------------------------------

mob81:                        ;slot
    cmp location,99
    jz nothap
    jmp noslot
    
; ************************************
;   TIMED EVENTS  
; ************************************

tpb:
    Invoke SetTextColor,light_magenta,0
    lea esi,ms435
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
timedevents:
    mov kpr,0
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    Invoke SetTextColor,light_cyan,0
    mov byte ptr flags[74],1
    cmp byte ptr flags[9],1    ;did time pass ?
    jz acts                    ;yes, goto timed actions
    mov byte ptr flags[9],1
    dec thirsty                ;thirsty = thirsty - 1
    jne @F                     ;thirsty = 0 ?
    Invoke SetTextColor,light_red,0
    lea esi,ms436
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,5000
    jmp fail

@@: cmp thirsty,3
    ja l5
    cmp thirsty,1
    ja @F
    lea esi,ms539
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
@@: cmp thirsty,2
    ja @F
    lea esi,ms438
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

@@: lea esi,ms437
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
l5: dec hungry                 ;hungry = hungry - 1
    jne @F
    Invoke SetTextColor,light_red,0
    lea esi,ms439
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,5000
    jmp fail
    
@@: cmp hungry,4
    jae l17
    cmp hungry,3
    jb @F
    lea esi,ms440
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
@@: cmp hungry,2
    jne @F
    lea esi,ms441
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

@@: lea esi,ms537
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
l17:
    dec tired                 ;tired = tired - 1
    jne @K
    lea esi,ms442
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    mov tired,137
    mov al,location
    cmp al,88
    jl @F
    mov al,65
    jmp wake
    
@@: cmp al,71
    jl @F
    mov al,40
    jmp wake
    
@@: cmp al,28
    jne @F
    cmp byte ptr flags[4],0
    jne @F
    mov al,42
    jmp wake
    
@@: mov al,5

wake:
    mov location,al
    invoke Sleep,4000
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms443
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    invoke Sleep,7000
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    lea esi,ms444
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov timeout,320
    jmp hifnl
    
@K: cmp tired,1
    ja @F
    lea esi,ms538
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov timeout,320
    jmp hifnl
    
@@: cmp tired,2
    ja @F
    lea esi,ms445
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov timeout,320
    jmp hifnl

@@: cmp tired,3
    ja tpb
    lea esi,ms446
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    movzx ecx,rowpos
    loc 0,ecx
    mov timeout,320
    jmp hifnl
    
acts:
    mov byte ptr flags[9],0   ;reset time passes flag
    movzx eax,location

SWITCH eax

    case 1
        jmp tpb
    case 2
        jmp tpb
    case 3
        jmp tpb
    case 4
        jmp tpb
    case 5
        jmp tpb
    case 6
        jmp tpb
    case 7
        jmp tpb
    case 8
        jmp flt2     ;fog
    case 9
        jmp flt1     ;bird
    case 10
        jmp flt3     ;old man
    case 11
        jmp flt1     ;bird
    case 12 
        jmp tpb
    case 13
        jmp tpb
    case 14 
        jmp tpb
    case 15
        jmp flt4     ;gypsy
    case 16
        jmp flt2     ;fog
    case 17
        jmp flt6     ;gorilla
    case 18
        jmp flt5
    case 19
        jmp flt6     ;gorilla
    case 20
        jmp tpb
    case 21
        jmp tpb
    case 22
        jmp tpb
    case 23
        jmp tpb
    case 24
        jmp flt2     ;fog
    case 25
        jmp flt6     ;gorilla
    case 26 
        jmp flt6     ;gorilla
    case 27
        jmp flt1     ;bird
    case 28 
        jmp tpb
    case 29
        jmp flt7     ;lake
    case 30
        jmp tpb
    case 31
        jmp flt9     ;gardener
    case 32
        jmp tpb
    case 33
        jmp tpb
    case 34
        jmp tpb
    case 35
        jmp flt10    ;fisherman
    case 36
        jmp tpb
    case 37
        jmp tpb
    case 38
        jmp flt8
    case 39
        jmp tpb
    case 40
        jmp tpb 
    case 41
        jmp flt12     ;tunnel
    case 42
        jmp flt14     ;landord
    case 43
        jmp flt11     ;pedlar
    case 44
        jmp tpb
    case 45
        jmp tpb
    case 46
        jmp flt15     ;guards
    case 47
        jmp tpb
    case 48
        jmp tpb
    case 49
        jmp tpb
    case 50
        jmp tpb
    case 51
        jmp flt13     ;gravedigger
    case 52 
        jmp flt15     ;guards
    case 53
        jmp flt20     ;jailer
    case 54 
        jmp flt15     ;guards
    case 55
        jmp tpb
    case 56
        jmp flt21     ;monk
    case 57
        jmp tpb
    case 58
        jmp tpb
    case 59
        jmp tpb
    case 60
        jmp flt15     ;guards
    case 61
        jmp flt15     ;guards
    case 62
        jmp tpb
    case 63
        jmp tpb
    case 64
        jmp tpb
    case 65
        jmp tpb
    case 66 
        jmp tpb
    case 67
        jmp tpb
    case 68 
        jmp tpb
    case 69
        jmp tpb
    case 70
        jmp tpb
    case 71
        jmp tpb
    case 72
        jmp tpb
    case 73
        jmp flt16     ;battlements
    case 74
        jmp tpb
    case 75
        jmp tpb
    case 76
        jmp sew
    case 77
        jmp tpb
    case 78
        jmp tpb
    case 79
        jmp flt22
    case 80
        jmp tpb
     case 81
        jmp flt16     ;battlements
    case 82
        jmp flt16     ;battlements
    case 83
        jmp tpb
    case 84
        jmp tpb
    case 85
        jmp tpb
    case 86
        jmp tpb
    case 87
        jmp tpb
    case 88
        jmp tpb
    case 89
        jmp flt16     ;battlements
    case 90
        jmp flt16     ;battlements
    case 91
        jmp tpb
    case 92
        jmp tpb
    case 93
        jmp tpb
    case 94
        jmp tpb
    case 95
        jmp tpb
    case 96
        jmp tpb
    case 97
        jmp tpb
    case 98
        jmp tpb
    case 99
        jmp flt17    ;bear
    case 100
        jmp tpb
    case 101
        jmp tpb
    case 102
        jmp tpb
    case 103
        jmp flt19    ;magpie
    case 104
        jmp tpb
    case 105
        jmp tpb
    case 106
        jmp tpb
    case 107
        jmp tpb
    case 108
        jmp tpb
    case 109
        jmp tpb
    case 110
         jmp flt18   ;statue
    case 111
        jmp tpb
    case 112
        jmp tpb

    DEFAULT
        jmp tpb
ENDSW

; -------------------------------------------------------------------------

flt1:                      ;bird
    cmp bread,128
    je @F
    lea esi,ms447
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
@@: mov bread,0
    dec carry
    lea esi,ms448
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt2:                      ;shape in fog
    lea esi,ms449
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt3:                      ;old man
    cmp byte ptr flags[4],1
    jz tpb
    mov al,location
    cmp oldman,al
    je @F
    mov oldman,al
    lea esi,ms450
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

@@: mov oldman,0
    lea esi,ms451
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt4:                      ;gypsy
    cmp byte ptr flags[11],0
    je @F
    mov al,location
    cmp gypsy,al
    jz @74
    jmp flt2
    
@@: mov byte ptr flags[11],1
    mov al,location
    mov gypsy,al
    lea esi,ms19
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,4
    mov timeout,320
    jmp hifnl
    
@74:
    lea esi,ms452
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt5:                      ;woodcutter
    cmp byte ptr flags[10],0
    jne tpb
    cmp byte ptr flags[59],0
    je tpb
    mov byte ptr flags[10],1
    lea esi,ms453
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,4
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt6:                      ;gorilla
    cmp carry,0
    jz tpb
    mov ecx,46
    lea edi,lamp+3
    
@@: inc edi
    dec ecx
    je tpb
    cmp ecx,9
    je @B
    cmp byte ptr[edi],192
    jne @h
    dec worn
    jmp @F

@h: cmp byte ptr[edi],128
    jne @B
    dec carry

@@: mov byte ptr[edi],1
    lea esi,ms454
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt7:                      ;lake monster
    cmp byte ptr flags[13],0
    jne @F
    mov byte ptr flags[13],1
    lea esi,ms455
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL

    add rowpos,2
    mov timeout,320
    jmp hifnl
    
@@: call hidecursor
    lea esi,ms456
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,8000
    jmp fail

; -------------------------------------------------------------------------
    
flt8:                      ;boots
    cmp boots,192
    je tpb
    call hidecursor
    lea esi,ms457
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,5000
    jmp fall

; -------------------------------------------------------------------------
    
flt9:                      ;gardener
    cmp byte ptr flags[12],0
    jne tpb
    mov byte ptr flags[12],1
    inc carry
    mov card,128
    lea esi,ms458
    movzx ecx,word ptr[esi]
    add esi,2
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,6
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt10:                     ;fisherman
    cmp byte ptr flags[68],0
    je tpb
    cmp byte ptr flags[69],0
    jne tpb
    mov byte ptr flags[69],1
    lea esi,directions-1
    or byte ptr [esi+43],64
    lea esi,ms459
    movzx ecx,word ptr[esi]
    add esi,2
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,5
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt11:                     ;pedlar
    cmp byte ptr flags[5],0
    je @F
    cmp byte ptr flags[61],1
    jz tpb
    
@@: mov al,location
    cmp pedlar,al
    je @F
    mov pedlar,al
    lea esi,ms460
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    mov timeout,320
    jmp hifnl
    
@@: mov pedlar,0
    lea esi,ms461
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt12:                     ;tunnel monster
    cmp byte ptr flags[8],0
    jne @F
    mov byte ptr flags[8],1
    lea esi,ms462
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
@@: call hidecursor
    lea esi,ms463
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,6000
    jmp fail

; -------------------------------------------------------------------------
    
flt13:                     ;gravedigger
    cmp byte ptr flags[7],0
    jne tpb
    mov byte ptr flags[7],1
    mov gravedigger,al
    lea esi,ms464
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt14:                     ;landlord
    mov al,location
    cmp landlord,al
    je ll4
    cmp byte ptr flags[59],0
    jne @F
    mov byte ptr flags[59],1
    mov landlord,al
    lea esi,ms465
    movzx ecx,word ptr[esi]
    add esi,2
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,5
    mov timeout,320
    jmp hifnl
    
    @@:
    mov landlord,al
    lea esi,ms466
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
    ll4:
    mov landlord,0
    lea esi,ms467
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------

    
flt15:                     ;castle guards
    cmp helmet,192
    je @F
    
g1: call hidecursor
    lea esi,ms468
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,7000
    jmp fail
    
@@: lea esi,ms469
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt16:                     ;monster on battlements
    cmp cloak,192
    je @F
    
g2: call hidecursor
    lea esi,ms470
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,8000
    jmp fail
    
@@: cmp byte ptr flags[56],0
    je g2
    lea esi,ms471
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt17:                     ;bear
    cmp byte ptr flags[15],0
    jne tpb
    mov al,location
    cmp bear,al
    jne @F
    mov byte ptr flags[16],0
    mov bear,0
    lea esi,ms472
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
@@: cmp byte ptr flags[16],0
    je tpb
    mov bear,al
    lea esi,ms473
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt18:                     ;statue
    cmp byte ptr flags[18],0
    jne @F
    mov byte ptr flags[18],1
    lea esi,ms474
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
@@: call hidecursor
    lea esi,ms475
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,7000
    jmp fail

; -------------------------------------------------------------------------
    
flt19:                     ;magpie
    cmp byte ptr flags[14],1
    je tpb
    cmp magpie,103
    jne @F
    mov magpie,0
    lea esi,ms476
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl
    
@@: mov magpie,103
    lea esi,ms477
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,2
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------
    
flt20:                     ;jailer
    cmp byte ptr flags[64],0
    je @F
    cmp jailer,53
    jne tpb
    cmp helmet,192
    je tpb
    call hidecursor
    lea esi,ms478
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,8000
    jmp fail
    
@@: lea esi,directions-1
    or byte ptr[esi+53],16
    mov al,location
    mov jailer,al
    cmp helmet,192
    je @F
    call hidecursor
    lea esi,ms479
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    call hidecursor
    invoke Sleep,7000
    jmp fail
    
@@: mov byte ptr flags[64],1
    lea esi,ms480
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,4
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------

flt21:                       ;monk
    cmp byte ptr flags[71],1
    jz tpb
    mov byte ptr flags[71],1
    lea esi,directions-1
    or byte ptr[esi+47],32
    lea esi,ms481
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    mov timeout,320
    jmp hifnl

; -------------------------------------------------------------------------

flt22:                       ;maid
    cmp byte ptr flags[73],1
    jne tpb
    cmp byte ptr flags[72],1
    jz tpb
    mov byte ptr flags[72],1
    lea esi,directions-1
    or byte ptr [esi+85],64
    lea esi,ms482
    movzx ecx,byte ptr[esi]
    inc esi
    invoke WriteConsoleA,hConsoleOutput,esi,ecx,ADDR numrit,NULL
    add rowpos,3
    mov timeout,320
    jmp hifnl

main endp

end start